// html.cpp
/*
Copyright (C) 2001-2004  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string>
#include <libcgi++.h>

#include "dbd.h"

#include "html.h"


void error(char *s)
{
	fprintf(out,"\n");		// End of http header

	fprintf(out,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n");
	fflush(out);
	fprintf(out,"<html><head><title>Error</title>");
	fprintf(out,"<link rel=\"STYLESHEET\" href=\"/style/dbd.css\" type=\"text/css\">");
	fprintf(out,"</head>\n");
	fprintf(out,"<body> <h1>Error</h1> This is the text of the error message: '%s' </body></html>\n",s);
	fflush(out);
	exit(-1);
}

void header_top(char *s,long useronline)
{
	fprintf(out,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n");
	fflush(out);
	fprintf(out,"<html><head><base target=rf><title>%s</title>",s);
	fprintf(out,"<link rel=\"STYLESHEET\" href=\"/style/dbd.css\" type=\"text/css\">");
	fprintf(out,"</head>\n");
	fprintf(out,"<body>"); // background=/image/dbdinnehall.gif BGPROPERTIES=fixed>\n");
	if (*s)
		fprintf(out,"<h3>%s</h3>",s);
	if (*errstr)
		fprintf(out,"<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ff8080\"><font size=\"+1\">%s</font></td></tr></table>\n",errstr);
	if (*warningstr)
		fprintf(out,"<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ffff80\"><font size=\"+1\">%s</font></td></tr></table>\n",warningstr);
}


// normal page header when user is logged in

void header0(char *s,long useronline,Cookies *cs)
{
	char slask[100];
	
	fprintf(out,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n");
	fflush(out);
	fprintf(out,"<html><head><base target=rf><title>%s</title>",s);
	fprintf(out,"<link rel=\"STYLESHEET\" href=\"/style/dbd.css\" type=\"text/css\">");
	fprintf(out,"</head>\n");
	fprintf(out,"<body>"); // background=/image/dbdinnehall.gif BGPROPERTIES=fixed>\n");
	// new menu
	std::string td_class = "x";
	std::string a_class = "x";
/*
			set_cookie(cs,"ui",0L);
			set_cookie(cs,"dba","0");
			set_cookie(cs,"ed","0");
*/
	bool design = false;
	bool ui = (cs -> getvalue("ui",slask,100) && *slask && atoi(slask)) ? true : false;
	bool dba = (cs -> getvalue("dba",slask,100) && *slask && atoi(slask)) ? true : false;
	bool ed = (cs -> getvalue("ed",slask,100) && *slask && atoi(slask)) ? true : false;
	cs -> getvalue("show_page",slask,100);
	int show_page = atoi(slask);
	bool sql = show_page == 20;
	bool diagram = show_page == 38;
	bool ls = show_page == 22;
	if (sql || diagram || ls)
	{
		ui = dba = ed = false;
	}
	if (!ui && !dba && !ed && !sql && !diagram && !ls)
	{
		design = true;
	}
	fprintf(out,"<table cellpadding=0 cellspacing=0><tr>");
	fprintf(out,"<td class=mbeg>&nbsp;</td>");

	td_class = design ? "y" : "x";
	fprintf(out,"<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?design=0\">design</a></td>",td_class.c_str(),a_class.c_str());
	td_class = ed ? "y" : "x";
	fprintf(out,"<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?ed=0\">edit&nbsp;data</a></td>",td_class.c_str(),a_class.c_str());
	td_class = diagram ? "y" : "x";
	fprintf(out,"<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?diagram=0\">diagram</a></td>",td_class.c_str(),a_class.c_str());
	td_class = sql ? "y" : "x";
	fprintf(out,"<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?sql=1\">generate&nbsp;sql</a></td>",td_class.c_str(),a_class.c_str());
	td_class = ui ? "y" : "x";
	fprintf(out,"<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?ui=0\">user&nbsp;info</a></td>",td_class.c_str(),a_class.c_str());
	td_class = dba ? "y" : "x";
	fprintf(out,"<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?dba=0\">db&nbsp;access</a></td>",td_class.c_str(),a_class.c_str());
	td_class = ls ? "y" : "x";
	fprintf(out,"<td class=%s><a class=%s href=\"/cgi-bin/dbd/dbd?ls=0\">live&nbsp;sync</a></td>",td_class.c_str(),a_class.c_str());
	td_class = "x";
	fprintf(out,"<td class=%s><a target=_top class=%s href=\"/cgi-bin/dbd/dbd?logout=0\">logout</a></td>",td_class.c_str(),a_class.c_str());

	fprintf(out,"</tr></table>");
	fprintf(out,"<div style=\"width: 100%; height: 8px; background: #c0c0c0\">");
	fprintf(out,"</div>");
	fprintf(out,"<div style=\"width: 100%; height: 4px; background: #ffffff\">");
	fprintf(out,"</div>");
	// end of new menu
	fprintf(out,"<div style=\"padding: 5px;\">");

	if (*s)
		fprintf(out,"<h3>%s</h3>",s);
	if (*errstr)
		fprintf(out,"<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ff8080\"><font size=\"+1\">%s</font></td></tr></table>\n",errstr);
	if (*warningstr)
		fprintf(out,"<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ffff80\"><font size=\"+1\">%s</font></td></tr></table>\n",warningstr);
}


// top header (useronline = 1), login header, new user header

void header(char *s,long useronline)
{
	fprintf(out,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n");
	fflush(out);
	fprintf(out,"<html><head><base target=rf><title>%s</title>",s);
//	if (*s)
//		fprintf(out,"<title>%s: %s</title>",TITLE,s);
//	else
//		fprintf(out,"<title>%s</title>",TITLE);
	fprintf(out,"<link rel=\"STYLESHEET\" href=\"/style/dbd.css\" type=\"text/css\">");
	fprintf(out,"</head>\n");
	fprintf(out,"<body>"); // bgcolor=\"#66ddfe\">");
	fprintf(out,"<table width=\"100%%\" cellpadding=0 cellspacing=0><tr><td valign=middle>");
	if (*s)
		fprintf(out,"<h1>%s: %s</h1>",TITLE,s);
	else
		fprintf(out,"<h1>%s</h1>",TITLE);
//		fprintf(out,"<img src=/image/dbdlogo.gif>");
	fprintf(out,"</td>");
	fprintf(out,"<td valign=top align=right>");
//	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>");
//	fprintf(out,"<input type=submit name=logout value=\" Logout \">");
//	fprintf(out,"</form>");

// useronline = 1 design
//  2 db access
//  3 user info
//  4 -
//  5 edit data
//  6 generate sql
//

	if (useronline)
	{
	useronline = 999;
		fprintf(out,"[\n");
		if (useronline == 1)
			fprintf(out,"design\n");
		else
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?design=0\">design</a>\n");
		fprintf(out,"|\n");
		fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?ed=0\">edit&nbsp;data</a>\n");
		fprintf(out,"|\n");
		fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?sql=1\">generate&nbsp;sql</a>\n");
		fprintf(out,"|\n");
		fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?diagram=0\">diagram</a>\n");
		fprintf(out,"|\n");
		if (useronline == 2)
			fprintf(out,"db&nbsp;access\n");
		else
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?dba=0\">db&nbsp;access</a>\n");
		fprintf(out,"|\n");
		if (useronline == 3)
			fprintf(out,"user&nbsp;info\n");
		else
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?ui=0\">user&nbsp;info</a>\n");
		fprintf(out,"|\n");
		fprintf(out,"<a target=_top href=\"/cgi-bin/dbd/dbd?logout=0\">logout</a>\n");
		fprintf(out,"]");
		fprintf(out,"<br>");
		fprintf(out,"[ <a href=\"/cgi-bin/dbd/dbd?ls=0\">live&nbsp;sync</a> ]");
	}
	fprintf(out,"</td></tr></table>");
	if (*errstr)
		fprintf(out,"<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ff8080\"><font size=\"+1\">%s</font></td></tr></table>",errstr);
	if (*warningstr)
		fprintf(out,"<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ffff80\"><font size=\"+1\">%s</font></td></tr></table>",warningstr);
}

void nullheader(char *s,long useronline)
{
	fprintf(out,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n");
	fflush(out);
	fprintf(out,"<html><head><title>%s</title>",s);
//	if (*s)
//		fprintf(out,"<title>%s: %s</title>",TITLE,s);
//	else
//		fprintf(out,"<title>%s</title>",TITLE);
	fprintf(out,"<link rel=\"STYLESHEET\" href=\"/style/dbd.css\" type=\"text/css\">");
	fprintf(out,"</head>\n");
	fprintf(out,"<body style=\"padding: 10px;\">"); // bgcolor=\"#66ddfe\">");
	fprintf(out,"<table width=\"100%%\" cellpadding=0 cellspacing=0><tr><td valign=middle>");
	if (*s)
		fprintf(out,"<h1>%s: %s</h1>",TITLE,s);
	else
		fprintf(out,"<h1>%s</h1>",TITLE);
//		fprintf(out,"<img src=/image/dbdlogo.gif>");
	fprintf(out,"</td>");
	fprintf(out,"<td valign=top align=right>");
//	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>");
//	fprintf(out,"<input type=submit name=logout value=\" Logout \">");
//	fprintf(out,"</form>");

// useronline = 1 design
//  2 db access
//  3 user info
//  4 -
//  5 edit data
//  6 generate sql
//

	if (useronline)
	{
	useronline = 999;
		fprintf(out,"[\n");
		if (useronline == 1)
			fprintf(out,"design\n");
		else
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?design=0\">design</a>\n");
		fprintf(out,"|\n");
		fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?ed=0\">edit&nbsp;data</a>\n");
		fprintf(out,"|\n");
		fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?sql=1\">generate&nbsp;sql</a>\n");
		fprintf(out,"|\n");
		fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?diagram=0\">diagram</a>\n");
		fprintf(out,"|\n");
		if (useronline == 2)
			fprintf(out,"db&nbsp;access\n");
		else
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?dba=0\">db&nbsp;access</a>\n");
		fprintf(out,"|\n");
		if (useronline == 3)
			fprintf(out,"user&nbsp;info\n");
		else
			fprintf(out,"<a href=\"/cgi-bin/dbd/dbd?ui=0\">user&nbsp;info</a>\n");
		fprintf(out,"|\n");
		fprintf(out,"<a target=_top href=\"/cgi-bin/dbd/dbd?logout=0\">logout</a>\n");
		fprintf(out,"]");
		fprintf(out,"<br>");
		fprintf(out,"[ <a href=\"/cgi-bin/dbd/dbd?ls=0\">live&nbsp;sync</a> ]");
	}
	fprintf(out,"</td></tr></table>");
	if (*errstr)
		fprintf(out,"<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ff8080\"><font size=\"+1\">%s</font></td></tr></table>",errstr);
	if (*warningstr)
		fprintf(out,"<table width=\"100%%\"><tr><td align=middle bgcolor=\"#ffff80\"><font size=\"+1\">%s</font></td></tr></table>",warningstr);
}

void footer()
{
	fprintf(out,"<br><br>[\n");
	fprintf(out,"<a target=_top href=\"/cgi-bin/dbd/dbd?repair=0\">repair frames</a>\n]<br>");
	fprintf(out,"<br>");
	fprintf(out,"</div>"); // padding 5px
	fprintf(out,"</body></html>\n");
}

// images

void iplus()
{
	fprintf(out,"<img src='/image/iplus-cont-0.gif' width=19 height=16 align=texttop border=0>");
}

void iplusend()
{
	fprintf(out,"<img src='/image/iplus-end-0.gif' width=19 height=16 align=texttop border=0>");
}

void iexpanded()
{
	fprintf(out,"<img src='/image/iminus-cont-0.gif' width=19 height=16 align=texttop border=0>");
}

void inotexpanded()
{
	fprintf(out,"<img src='/image/iplus-cont-0.gif' width=19 height=16 align=texttop border=0>");
}

void iclosed()
{
	fprintf(out,"<img src='/image/ifolder-closed-0.gif' width=16 height=16 align=texttop border=0>");
}

void iminus()
{
	fprintf(out,"<img src='/image/iminus-cont-0.gif' width=19 height=16 align=texttop border=0>");
}

void iminusend()
{
	fprintf(out,"<img src='/image/iminus-end-0.gif' width=19 height=16 align=texttop border=0>");
}

void iopen()
{
	fprintf(out,"<img src='/image/ifolder-open-0.gif' width=16 height=16 align=texttop border=0>");
}

void ivertline()
{
	fprintf(out,"<img src='/image/ivert-line-0.gif' width=19 height=16 align=texttop border=0>");
}

void ibranchcont()
{
	fprintf(out,"<img src='/image/ibranch-cont-0.gif' width=19 height=16 align=texttop border=0>");
}

void ibranchend()
{
	fprintf(out,"<img src='/image/ibranch-end-0.gif' width=19 height=16 align=texttop border=0>");
}

void iglobe()
{
	fprintf(out,"<img src='/image/globe.gif' width=16 height=16 align=texttop border=0>");
}

void iglobe0()
{
	fprintf(out,"<img src='/image/iglobe-0.gif' width=16 height=16 align=texttop border=0>");
}

void ithumbsup()
{
	fprintf(out,"<img src='/image/thumbsup2.gif' height=16 align=texttop border=0>");
}

void ithumbsdown()
{
	fprintf(out,"<img src='/image/thumbsdn2.gif' height=16 align=texttop border=0>");
}

void ipascal()
{
	fprintf(out,"<img src='/image/pascal.gif' height=16 align=texttop border=0>");
}

void iempty()
{
	fprintf(out,"<img src='/image/iempty.gif' height=16 align=texttop border=0>");
}
