// livedb.cpp
/*
Copyright (C) 2001-2004  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql/mysql.h>
#include <libmysqlwrapped.h>
#include <libdbd.h>
#include <string>
#include <libcgi++.h>
#include <stdint.h>

#include "dbd.h"
#include "html.h"
#include "utils.h"

#define QTOFLDS 2


typedef std::vector<db::Flds *> fld_v;
typedef std::map<std::string, uint64_t> enumset_m;


void read_primary(Database &db, Query& q, char *sql, db::Tbls *stbl, fld_v& ref)
{
	// read primary index for table
	sprintf(sql, "select * from indexs where tblnum=%ld and typ='PRIMARY'", stbl -> num);
	db::Indexs primary_index(&db, sql);
	if (primary_index.num)
	{
		sprintf(sql, "select * from indexlist where indexnum=%ld", primary_index.num);
		q.get_result(sql);
		while (q.fetch_row())
		{
			db::Indexlist x(&db, &q);
			ref.push_back(new db::Flds(db, x.fldnum));
		}
		q.free_result();
	}
}


bool fld_in_primary(db::Flds *fld, fld_v& ref)
{
	for (fld_v::iterator it = ref.begin(); it != ref.end(); it++)
	{
		db::Flds *p = *it;
		if (p -> num == fld -> num)
		{
			return true;
		}
	}
	return false;
}


// td == 1, th == "", ingorefield == -1
void visa_livedata(Database& db, Database& livedb, Query *lq, // dbd database, live database, query to show
	db::Flds **flds, 		// fields to show
	long qty, 			// number of fields in flds[]
	db::Tbls *stbl, 			// table that is shown
	short bold, 			// not used
	db::Access *a,
	db::Users *user,
	fld_v& primary_key_fields)	// primary key fields
{
	Query q(db);
	Query lq2(livedb);
	db::Tbls *totbl;
	db::Flds *toflds[QTOFLDS];
	long l;
	long qflds;
	int i, j;
	char sql[999];
	char slask[200];

	fprintf(out,"<tr>");
	for (i = 0; i < qty; i++)	// visa data pa en rad
	{
		if (lq -> is_null(i))
		{
			fprintf(out,"<td class=tab valign=top><font size=\"-1\" style=\"font-family: courier;\">NULL</font></td>");
		}
		else
		switch (flds[i] -> fieldtype)
		{
		case 2: // int(x)
			if (i)
			{
//				fprintf(out,"<td class=tab align=right valign=top><font size=\"-1\">%ld</font></td>", lq -> getval(i));
				fprintf(out,"<td class=tab align=right valign=top><font size=\"-1\">%s</font></td>", lq -> getstr(i));
			}
			else
			{
				// assumption: first field is always primary key: integer auto_increment
				fprintf(out,"<td class=tab valign=top>");

				fprintf(out,"<table width=\"100%%\" cellpadding=0 cellspacing=0><tr>");
//				fprintf(out,"<td align=middle><font size=\"-1\">%ld</font></td>", lq -> getval(i));
				fprintf(out,"<td align=middle><font size=\"-1\">%s</font></td>", lq -> getstr(i));
				fprintf(out,"<td align=right>");
				if (bold&&0)
					fprintf(out,"<a name=edit>");
				fprintf(out,"<font size=\"-1\">");
				strcpy(slask, "&nbsp;[&nbsp;");
				if (a -> wdata)
				{
					fprintf(out,"%s<a href=/cgi-bin/dbd/dbd?ednr=%ld#edit>edit</a>", slask, lq -> getval(i));
					strcpy(slask, "&nbsp;|&nbsp;");
				}
			// kolla om det finns tabeller som lankar till denna post
				sprintf(sql, "select num from flds where ptrtotblnum=%ld order by tblnum", stbl -> num);
				if (q.get_count(sql))
				{
				// 'links' - visa data
				// %! 'insert' - insert data - what was the idea here anyway?
				//                              show insert form for linked table probably..
					fprintf(out,"%s<a href=/cgi-bin/dbd/dbd?linknr=%ld>links</a>", slask, lq -> getval(i));
//					fprintf(out,"&nbsp;|&nbsp;<a href=/cgi-bin/dbd/dbd?ilinknr=%ld>insert</a>", lq -> getval(i));
					strcpy(slask, "&nbsp;|&nbsp;");
				}
				if (*slask == '&')
				{
					fprintf(out,"&nbsp;]");
				}
				fprintf(out,"</font>");
				if (bold&&0)
					fprintf(out,"</a>");
				fprintf(out,"</td>");
				fprintf(out,"</tr></table>");

				fprintf(out,"</td>");
			}
			break;
		case 1: // char(x)
		case 3: // datetime
			fprintf(out,"<td class=tab valign=top>");
			if (!strcasecmp(flds[i] -> fieldstr.c_str(), "char") ||
			    !strcasecmp(flds[i] -> fieldstr.c_str(), "varchar") ||
			    !strcasecmp(flds[i] -> fieldstr.c_str(), "datetime") ||
			    !strcasecmp(flds[i] -> fieldstr.c_str(), "date") 
			    )
			{
				size_t cutoff = user -> cutoff < 190 ? user -> cutoff : 190;
				strncpy(slask, lq -> getstr(i), cutoff);
				if (strlen(lq -> getstr(i) ) > cutoff)
				{
					slask[cutoff + 0] = ' ';
					slask[cutoff + 1] = '.';
					slask[cutoff + 2] = '.';
					slask[cutoff + 3] = '.';
					slask[cutoff + 4] = 0;
				}
				fprintf(out,"<font size=\"-1\">%s</font>", slask);
			}
			else
			{
				fprintf(out,"<font size=\"-1\">--- text field ---</font>");
			}
			fprintf(out,"</td>");
			break;
		case 4: // enum
			fprintf(out,"<td class=tab valign=top><span class=enum>%s</span></td>", lq -> getstr(i) );
			break;
		case 7: // set
			fprintf(out,"<td class=tab valign=top><span class=enum>%s</span></td>", lq -> getstr(i) );
			break;
		case 5: // ptrtotblnum
			if (flds[i] -> ptrtotblnum)
			{
				l = lq -> getval(i); // num in field(0) in table
				totbl = new db::Tbls(db, flds[i] -> ptrtotblnum);
				sprintf(sql, "select num from flds where tblnum=%ld and deleted=0 order by ordning", totbl -> num);
				q.get_result(sql);
				qflds = q.num_rows();
				j = 0;
				while (q.fetch_row())
				{
					if (j < QTOFLDS)
					{
						toflds[j] = new db::Flds(db, q.getval());
					}
					j++;
				}
				q.free_result();
				while (j < QTOFLDS)
				{
					toflds[j++] = NULL;
				}

				fprintf(out,"<td class=tab valign=top>");
				fprintf(out,"<font size=\"-1\">");
				if (l)
				{
					strcpy(slask, "select ");
					*sql = 0;
					for (j = 0; j < (qflds < QTOFLDS ? qflds : QTOFLDS); j++)
					{
						sprintf(sql + strlen(sql), "%s%s", slask, toflds[j] -> name.c_str());
						strcpy(slask, ", ");
					}
					sprintf(sql + strlen(sql), " from %s where %s=%ld", totbl -> name.c_str(), toflds[0] -> name.c_str(), l);
					lq2.get_result(sql);
					if (lq2.fetch_row())
					{
						*slask = 0;
						for (j = 0; j < (qflds < QTOFLDS ? qflds : QTOFLDS); j++)
						{
							fprintf(out,"%s%s", slask, lq2.getstr());
							strcpy(slask, " / ");
						}
					}
					lq2.free_result();
				}
				fprintf(out,"</font>");
				fprintf(out,"</td>");

				// delete to table stuff
				for (j = 0; j < qflds; j++)
				{
					if (j < QTOFLDS && toflds[j])
					{
						delete toflds[j];
					}
				}
				delete totbl;
			}
			else
			{
				fprintf(out,"<td class=tab></td>");
			}
			break;
		case 6: // number
/*
			{
				sprintf(slask, "<font size=\"-1\">%%.%ldf</font>", flds[i] -> decimallength);
				fprintf(out,"<td class=tab valign=top align=right>");
				printf(slask, lq -> getnum(i));
				fprintf(out,"</td>");
			}
*/
			fprintf(out,"<td class=tab align=right valign=top><font size=\"-1\">%s</font></td>", lq -> getstr(i));
			break;
		}
	}
	fprintf(out,"</tr>"); // end of data row

} // visa_livedata (td == 1, th == "")


// td == 0, th == table name, ignorefield >= 0
void visa_livedata_sub(Database& db, Database& livedb, Query *lq, // dbd database, live database, query to show
	db::Flds **flds, 		// fields to show
	long qty, 			// number of fields in flds[]
	const std::string& th, 		// td=1 / "", td=0 / table name in "links" view
	long ignorefield, 		// primary index field in "links" view only, otherwise -1
	db::Tbls *stbl, 			// table that is shown
	short bold, 			// not used
	db::Access *a,
	db::Users *user,
	fld_v& primary_key_fields)	// primary key fields
{
	Query q(db);
	Query lq2(livedb);
	db::Tbls *totbl;
	db::Flds *toflds[QTOFLDS];
	long l;
	long qflds;
	int i, j;
	char sql[999];
	char slask[200];

	fprintf(out,"<tr>");
	fprintf(out,"<th align=right bgcolor=\"#e0e0e0\" valign=top><font size=\"-1\">%s</font></th>", th.c_str());
	fprintf(out,"<td class=tab colspan=%ld valign=top>", qty);
	for (i = 0; i < qty; i++)	// visa data pa en rad
	if (i != ignorefield)
	{
		if (i && i < qty - 1)
		{
			fprintf(out,", ");
		}
		if (lq -> is_null(i))
		{
			fprintf(out,"<font size=\"-1\" style=\"font-family: courier;\">NULL</font>");
		}
		else
		switch (flds[i] -> fieldtype)
		{
		case 2: // int(x)
//			fprintf(out,"<font size=\"-1\">%ld</font>", lq -> getval(i));
			fprintf(out,"<font size=\"-1\">%s</font>", lq -> getstr(i));
			break;
		case 1: // char(x)
		case 3: // datetime
			if (!strcasecmp(flds[i] -> fieldstr.c_str(), "char") ||
			    !strcasecmp(flds[i] -> fieldstr.c_str(), "varchar"))
			{
				size_t cutoff = user -> cutoff < 190 ? user -> cutoff : 190;
				strncpy(slask, lq -> getstr(i), cutoff);
				if (strlen(lq -> getstr(i) ) > cutoff)
				{
					slask[cutoff + 0] = ' ';
					slask[cutoff + 1] = '.';
					slask[cutoff + 2] = '.';
					slask[cutoff + 3] = '.';
					slask[cutoff + 4] = 0;
				}
				fprintf(out,"<font size=\"-1\">%s</font>", slask);
			}
			else
			{
				fprintf(out,"<font size=\"-1\">--- text field ---</font>");
			}
			break;
		case 4: // enum
			fprintf(out,"<span class=enum>%s</span>", lq -> getstr(i));
			break;
		case 7: // set
			fprintf(out,"<span class=enum>%s</span>", lq -> getstr(i));
			break;
		case 5: // ptrtotblnum
			if (flds[i] -> ptrtotblnum)
			{
				l = lq -> getval(i); // num in field(0) in table
				totbl = new db::Tbls(db, flds[i] -> ptrtotblnum);
				sprintf(sql, "select num from flds where tblnum=%ld and deleted=0 order by ordning", totbl -> num);
				q.get_result(sql);
				qflds = q.num_rows();
				j = 0;
				while (q.fetch_row())
				{
					if (j < QTOFLDS)
					{
						toflds[j] = new db::Flds(db, q.getval());
					}
					j++;
				}
				q.free_result();
				while (j < QTOFLDS)
				{
					toflds[j++] = NULL;
				}

				fprintf(out,"<font size=\"-1\">");
				if (l)
				{
					strcpy(slask, "select ");
					*sql = 0;
					for (j = 0; j < (qflds < QTOFLDS ? qflds : QTOFLDS); j++)
					{
						sprintf(sql + strlen(sql), "%s%s", slask, toflds[j] -> name.c_str());
						strcpy(slask, ", ");
					}
					sprintf(sql + strlen(sql), " from %s where %s=%ld", totbl -> name.c_str(), toflds[0] -> name.c_str(), l);
					lq2.get_result(sql);
					if (lq2.fetch_row())
					{
						*slask = 0;
						for (j = 0; j < (qflds < QTOFLDS ? qflds : QTOFLDS); j++)
						{
							fprintf(out,"%s%s", slask, lq2.getstr());
							strcpy(slask, " / ");
						}
					}
					lq2.free_result();
				}
				fprintf(out,"</font>");

				// delete to table stuff
				for (j = 0; j < qflds; j++)
				{
					if (j < QTOFLDS && toflds[j])
					{
						delete toflds[j];
					}
				}
				delete totbl;
			}
			break;
		case 6: // number
/*
			{
				sprintf(slask, "<font size=\"-1\">%%.%ldf</font>", flds[i] -> decimallength);
				printf(slask, lq -> getnum(i));
			}
*/
			fprintf(out,"<font size=\"-1\">%s</font>", lq -> getstr(i));
			break;
		}
	}
	fprintf(out,"</td>");
	fprintf(out,"</tr>"); // end of data row

} // visa_livedata_sub (td == 0, th == table name)


void edit_livedata(Database& db,Database& livedb, Query& q, Query& lq2, char *sql,
	db::Flds **flds, enumset_m **mmaps, long qty, long ednr, Query& lq, db::Access *a)
{
	char slask[256];

	fprintf(out,"<tr><td colspan=%ld>", qty);
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>");
	fprintf(out,"<input type=hidden name=ed value=\"1\">");
	fprintf(out,"<input type=hidden name=ednr value=\"%ld\">", ednr);
	fprintf(out,"<table>");

	for (int i = 0; i < qty; i++)
	{
		fprintf(out,"<tr>");
		switch (flds[i] -> fieldtype)
		{
		case 1: // char(x)
			fprintf(out,"<th class=edit align=right valign=top>%s</th>", flds[i] -> name.c_str());
			if (strstr(flds[i] -> fieldstr.c_str(), "BLOB"))
			{
				fprintf(out,"<td class=edit valign=top> ---- </td>");
			}
			else
			if (strstr(flds[i] -> fieldstr.c_str(), "TEXT"))
			{
				fprintf(out,"<td class=edit valign=top><textarea name=%s rows=12 cols=80 wrap=off>", flds[i] -> name.c_str());
				size_t l = strlen(lq.getstr(i)) + 10000;
				if (l > 32767)
				{
					l = 32767;
				}
				char *temp = new char[l]; // strlen(lq.getstr(i)) + 10000];
				strcpy(temp, lq.getstr(i));
				remove_br(temp);
				fprintf(out,"%s", temp);
				delete temp;
				fprintf(out,"</textarea></td>");
			}
			else
			{
				fprintf(out,"<td class=edit valign=top><input type=text name=%s value=\"%s\" size=%ld></td>",
				 flds[i] -> name.c_str(), lq.getstr(i), (flds[i] -> charlength < 80 ? flds[i] -> charlength + 1 : 80));
			}
			break;
		case 2: // int(x)
			fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
			if ((flds[i] -> fieldflags & FF_AUTO_INCREMENT) != 0)
			{
//				fprintf(out,"<td class=edit> <b>%ld</b> </td>", lq.getval(i));
				fprintf(out,"<td class=edit> <b>%s</b> </td>", lq.getstr(i));
			}
			else
			{
//				fprintf(out,"<td class=edit><input type=text name=%s value=%ld size=%ld></td>", flds[i] -> name.c_str(), lq.getval(i), flds[i] -> integerlength + 1);
				fprintf(out,"<td class=edit><input type=text name=%s value=\"%s\" size=%ld></td>", flds[i] -> name.c_str(), lq.getstr(i), flds[i] -> integerlength + 1);
			}
			break;
		case 3: // datetime
			fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
			fprintf(out,"<td class=edit><input type=text name=%s value=\"%s\" size=%d></td>",
			 flds[i] -> name.c_str(), lq.getstr(i), 40);
			break;
		case 4: // enum
			fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
			fprintf(out,"<td class=edit><select name=%s>", flds[i] -> name.c_str());
/*
			fprintf(out,"<option value=\"%s\">%s", lq.getstr(i), lq.getstr(i));
			{
				cgi::Parse *pa = new cgi::Parse( (char *)flds[i] -> options.c_str(), "/,");
				pa -> getword(slask);
				while (*slask)
				{
					if (name_ok(slask) && strcmp(slask, lq.getstr(i)))
					{
						fprintf(out,"<option value=\"%s\">%s", slask, slask);
					}
					pa -> getword(slask);
				}
				delete pa;
			}
*/
			{
				std::string curval = lq.getstr(i);
				for (enumset_m::iterator it = mmaps[i] -> begin(); it != mmaps[i] -> end(); it++)
				{
					std::string str = (*it).first;
					uint64_t val = (*it).second;
					fprintf(out,"<option value=\"%lld\"%s>%s",val,
						!strcasecmp(str.c_str(),curval.c_str()) ? " SELECTED" : "",
						str.c_str());
				}
			}
			fprintf(out,"</select></td>");
			break;
		case 5: // ptrtotblnum
			fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
			if (flds[i] -> ptrtotblnum)
			{
				long l = lq.getval(i); // num in field(0) in table
				db::Tbls *totbl = new db::Tbls(db, flds[i] -> ptrtotblnum);
				db::Flds *toflds[QTOFLDS];
				sprintf(sql, "select num from flds where tblnum=%ld and deleted=0 order by ordning", totbl -> num);
				q.get_result(sql);
				int qflds = q.num_rows();
				int j = 0;
				while (q.fetch_row())
				{
					if (j < QTOFLDS)
					{
						toflds[j] = new db::Flds(db, q.getval());
					}
					j++;
				}
				q.free_result();
				while (j < QTOFLDS)
				{
					toflds[j++] = NULL;
				}

				fprintf(out,"<td class=edit><select name=%s>", flds[i] -> name.c_str());
				if (l)
				{
					strcpy(slask, "select ");
					*sql = 0;
					for (j = 0; j < (qflds < QTOFLDS ? qflds : QTOFLDS); j++)
					{
						sprintf(sql + strlen(sql), "%s%s", slask, toflds[j] -> name.c_str());
						strcpy(slask, ", ");
					}
					sprintf(sql + strlen(sql), " from %s where %s=%ld", totbl -> name.c_str(), toflds[0] -> name.c_str(), l);
					lq2.get_result(sql);
					if (lq2.fetch_row())
					{
						if (!toflds[1]) //qn == 1)
						{
							fprintf(out,"<option>%s", lq2.getstr());
						}
						else
						{
							fprintf(out,"<option value=\"%s\">%s / %s",
							 lq2.getstr(0), lq2.getstr(0), lq2.getstr(1));
						}
					}
					lq2.free_result();
				}
				else
				{
					fprintf(out,"<option value=\"0\">");
				}

				if (!toflds[1]) //qn == 1)
				{
					sprintf(sql, "select %s from %s where %s<>%ld order by %s",
					 toflds[0] -> name.c_str(), totbl -> name.c_str(), toflds[0] -> name.c_str(), l, toflds[0] -> name.c_str());
				}
				else
				{
					sprintf(sql, "select %s, %s from %s where %s<>%ld order by %s",
					 toflds[0] -> name.c_str(), toflds[1] -> name.c_str(), totbl -> name.c_str(), toflds[0] -> name.c_str(), l, toflds[0] -> name.c_str());
				}
				lq2.get_result(sql);
				while (lq2.fetch_row())
				{
					if (!toflds[1]) //qn == 1)
					{
						fprintf(out,"<option>%s", lq2.getstr());
					}
					else
					{
						fprintf(out,"<option value=\"%s\">%s / %s",
						 lq2.getstr(0), lq2.getstr(0), lq2.getstr(1));
					}
				}
				lq2.free_result();
				if (l)
				{
					fprintf(out,"<option value=\"0\">");
				}

				fprintf(out,"</select></td>");

				// delete to table stuff
				for (j = 0; j < qflds; j++)
				{
					if (j < QTOFLDS && toflds[j])
					{
						delete toflds[j];
					}
				}
				delete totbl;
			}
			else
			{
				fprintf(out,"<td class=edit></td>");
			}
			break;
		case 6: // number
			fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
			fprintf(out,"<td class=edit><input type=text name=%s value=\"%s\" size=%ld></td>",
			 flds[i] -> name.c_str(), lq.getstr(i), flds[i] -> integerlength + flds[i] -> decimallength + 1);
			break;
		case 7: // set
			fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
			fprintf(out,"<td class=edit>");
			{
				set_t x(*mmaps[i]);
				x = lq.getstr(i);
				for (enumset_m::iterator it = mmaps[i] -> begin(); it != mmaps[i] -> end(); it++)
				{
					std::string str = (*it).first;
					uint64_t bit = (*it).second;
					if (bit)
					{
						fprintf(out,"<span class=enum><input type=checkbox name=%s value=\"%lld\"%s>",
							flds[i] -> name.c_str(),bit,(x.Value() & bit) ? " CHECKED" : "");
						fprintf(out,"%s&nbsp;</span>",str.c_str());
					}
				}
			}
			fprintf(out,"</td>");
/*
			{
				cgi::Parse *pa = new cgi::Parse( (char *)flds[i] -> options.c_str(), "/,");
				pa -> getword(slask);
				while (*slask)
				{
					if (name_ok(slask) && strcmp(slask, lq.getstr(i)))
					{
						fprintf(out,"<option value=\"%s\">%s", slask, slask);
					}
					pa -> getword(slask);
				}
				delete pa;
			}
*/
			break;
		}
		fprintf(out,"</tr>");
	}
	fprintf(out,"<tr><td class=edit colspan=2 align=center>");

	fprintf(out,"<table><tr><td>");
	if (a -> wdata)
	{
		fprintf(out,"<input type=submit name=submit value=\" Update \">");
		fprintf(out,"</td><td>");
		fprintf(out,"<input type=submit name=submit value=\" Delete \">");
		fprintf(out,"</td><td>");
	}
	fprintf(out,"<input type=submit name=submit value=\" Cancel \">");
	fprintf(out,"</td></tr></table>");

	fprintf(out,"</td></tr></table>");
	fprintf(out,"</form>");
	fprintf(out,"</td></tr>");

} // edit_livedata


void livedata(Database& db, db::Dbs *sdb, db::Tbls *stbl, Form *form, Cookies *cs, db::Users *user, db::Access *a)
{
	SysLog log("livedata");
	Database livedb("localhost", "root", "", sdb -> name, &log);
//	livedb.RegErrHandler(&log);
	Query q(db), q2(db);
	Query lq(livedb), lq2(livedb);
	Query *lqd = new Query(livedb);
	db::Flds **flds, *toflds[QTOFLDS];
	cgi::Parse *pa;
	db::Tbls *totbl;
	db::Tbls *fromtbl;
	db::Flds *tempfld;
	db::Flds **fromflds;
	char *sql = new char[32000];
	char *temp;
	double d;
	long qty;
	long ednr = 0;
	long l;
	long qflds;	// in totbl
	long num;
	long linknr = 0;
	long stepnum;
	long maxnum;
	int i, j;
	short errcode = 0; //livedb.errcode();
	char slask[200];
	char str[80];
	enumset_m **mmaps;

	// read primary index fields
	fld_v vec;
	read_primary(db, q, sql, stbl, vec);

// get current start row
	if (cs -> getvalue("stepnum", slask, 20))
	{
		stepnum = atol(slask);
	}
	else
	{
		stepnum = 1;
	}

// get fields
	sprintf(sql, "select * from flds where tblnum=%ld and deleted=0 order by ordning", stbl -> num);
	q.get_result(sql);
	qty = q.num_rows();
	flds = new db::Flds *[qty];
	mmaps = new enumset_m *[qty];
	for (i = 0; i < qty; i++)
	{
		flds[i] = NULL;
		mmaps[i] = NULL;
	}
	i = 0;
	while (q.fetch_row())
	{
		flds[i] = new db::Flds(&db, &q);
		switch (flds[i] -> fieldtype)
		{
		case 4: // enum
			{
				cgi::Parse *pa = new cgi::Parse( (char *)flds[i] -> options.c_str(), "/,");
				mmaps[i] = new enumset_m;
				uint64_t val = 1;
				pa -> getword(slask);
				while (*slask)
				{
					if (*slask && *slask != ' ')
					{
						std::string tmp = slask;
						(*mmaps[i])[tmp] = val;
						val++;
					}
					//
					pa -> getword(slask);
				}
				delete pa;
			}
			break;
		case 7: // set
			{
				cgi::Parse *pa = new cgi::Parse( (char *)flds[i] -> options.c_str(), "/,");
				mmaps[i] = new enumset_m;
				uint64_t val = 1;
				pa -> getword(slask);
				while (*slask)
				{
					if (*slask && *slask != ' ')
					{
						std::string tmp = slask;
						(*mmaps[i])[tmp] = val;
						val = val * 2;
					}
					//
					pa -> getword(slask);
				}
				delete pa;
			}
			break;
		}
		//
		i++;
	}
	q.free_result();


// edit live data - process the "ed" form post
	*sql = 0;
	if (form -> getvalue("ed", slask, 20) && *slask && atoi(slask))
	{
		form -> getvalue("submit", slask, 200);
		if (a -> wdata && !strcmp(slask, " Delete "))
		{
			if (form -> getvalue("ednr", slask, 20))
				ednr = atol(slask);
			if (ednr)
			{
				sprintf(sql, "delete from %s where %s=%ld",
				 stbl -> name.c_str(), flds[0] -> name.c_str(), ednr);
				lq.execute(sql);
			}
		} 
		else
		if (a -> wdata && !strcmp(slask, " Update "))
		{
			if (form -> getvalue("ednr", slask, 20))
				ednr = atol(slask);
			if (ednr)
			{
				sprintf(str, "update %s set ", stbl -> name.c_str());
				*sql = 0;
				for (i = 1; i < qty; i++)
				{
					switch (flds[i] -> fieldtype)
					{
						case 1: // char
							if (strstr(flds[i] -> fieldstr.c_str(), "TEXT"))
							{
								l = form -> getlength( (char *)flds[i] -> name.c_str());
								temp = new char[l + 1440];
								form -> getvalue( (char *)flds[i] -> name.c_str(), temp, l + 144);
								textareain(temp);
								if (*temp || (flds[i] -> fieldflags & FF_ALLOWNULL) == 0)
								{
									sprintf(sql + strlen(sql), "%s%s='%s'",
									 str, flds[i] -> name.c_str(), q.safestr(temp).c_str());
								}
								delete temp;
								break;
							}
						case 3: // datetime
							form -> getvalue( (char *)flds[i] -> name.c_str(), slask, 200);
							if (*slask || (flds[i] -> fieldflags & FF_ALLOWNULL) == 0)
							{
								sprintf(sql + strlen(sql), "%s%s='%s'",
								 str, flds[i] -> name.c_str(), q.safestr(slask).c_str());
							}
							break;
						case 2: // int
						case 5:
							form -> getvalue( (char *)flds[i] -> name.c_str(), slask, 200);
							if (*slask || (flds[i] -> fieldflags & FF_ALLOWNULL) == 0)
							{
								sprintf(sql + strlen(sql), "%s%s=%ld",
								 str, flds[i] -> name.c_str(), atol(slask));
							}
							break;
						case 6: // number
							form -> getvalue( (char *)flds[i] -> name.c_str(), slask, 200);
							if (*slask || (flds[i] -> fieldflags & FF_ALLOWNULL) == 0)
							{
								d = atof(slask);
								sprintf(slask, "%%s%%s=%%.%ldf", flds[i] -> decimallength);
								sprintf(sql + strlen(sql), slask,
								 str, flds[i] -> name.c_str(), d);
							}
							break;
						case 4: // enum
							form -> getvalue( (char *)flds[i] -> name.c_str(), slask, 200);
							if (*slask || (flds[i] -> fieldflags & FF_ALLOWNULL) == 0)
							{
								enum_t x(*mmaps[i]);
								x = atoi(slask);
								sprintf(sql + strlen(sql), "%s%s='%s'",
								 str, flds[i] -> name.c_str(), q.safestr(x.c_str()).c_str());
							}
							break;
						case 7: // set
							{
								char name[500];
								set_t x(*mmaps[i]);
								form -> getfirst(name, 500, slask, 200);
								while (*name)
								{
									if (!strcmp(name, flds[i] -> name.c_str()))
									{
										x |= atoi(slask); // %! 32 bit only
									}
									//
									form -> getnext(name, 500, slask, 200);
								}
								if (x.Value() || (flds[i] -> fieldflags & FF_ALLOWNULL) == 0)
								{
									sprintf(sql + strlen(sql), "%s%s='%s'",
									 str, flds[i] -> name.c_str(), q.safestr(x.c_str()).c_str());
								}
							}
							break;
					}
					strcpy(str, ", ");
				}
				sprintf(sql + strlen(sql), " where %s=%ld", flds[0] -> name.c_str(), ednr);
				if (qty > 1)
					lq.execute(sql);
			}
		} 
		else
		if (a -> wdata && !strcmp(slask, " Insert "))
		{
			if (form -> getvalue("ednr", slask, 20))
				ednr = atol(slask);
			if (!ednr)
			{
				sprintf(str, "insert into %s (", stbl -> name.c_str());
				*sql = 0;
				for (i = 0; i < qty; i++)
				{
					// get field value
					if ((flds[i] -> fieldflags & FF_AUTO_INCREMENT) != 0)
					{
						sprintf(slask, "select max(%s) from %s",
						 flds[0] -> name.c_str(), stbl -> name.c_str());
						l = lq.get_count(slask);
						sprintf(slask, "%ld", l + 1);
						ednr = l + 1;
					} 
					else
					{
						form -> getvalue( (char *)flds[i] -> name.c_str(), slask, 200);
					}
					//
					if (*slask || (flds[i] -> fieldflags & FF_ALLOWNULL) == 0)
					{
						strcat(sql, str);
						strcat(sql, flds[i] -> name.c_str());
						strcpy(str, ", ");
					}
				}
				strcpy(str, ") values (");

				for (i = 0; i < qty; i++)
				{
					// get field value
					if ((flds[i] -> fieldflags & FF_AUTO_INCREMENT) != 0)
					{
						sprintf(slask, "select max(%s) from %s",
						 flds[0] -> name.c_str(), stbl -> name.c_str());
						l = lq.get_count(slask);
						sprintf(slask, "%ld", l + 1);
						ednr = l + 1;
					} 
					else
					{
						form -> getvalue( (char *)flds[i] -> name.c_str(), slask, 200);
					}
					//
					if (*slask || (flds[i] -> fieldflags & FF_ALLOWNULL) == 0)
					switch (flds[i] -> fieldtype)
					{
						case 1: // char
							if (strstr(flds[i] -> fieldstr.c_str(), "TEXT"))
							{
								l = form -> getlength( (char *)flds[i] -> name.c_str());
								temp = new char[l + 1440];
								form -> getvalue( (char *)flds[i] -> name.c_str(), temp, l + 144);
								textareain(temp);
								sprintf(sql + strlen(sql), "%s'%s'",
								 str, q.safestr(temp).c_str());
								delete temp;
								break;
							}
						case 3: // datetime
							sprintf(sql + strlen(sql), "%s'%s'",
							 str, q.safestr(slask).c_str());
							break;
						case 2: // int
						case 5:
							sprintf(sql + strlen(sql), "%s%ld",
							 str, atol(slask));
							break;
						case 6: // number
							d = atof(slask);
							sprintf(slask, "%%s%%s=%%.%ldf", flds[i] -> decimallength);
							sprintf(sql + strlen(sql), slask,
							 str, flds[i] -> name.c_str(), d);
							break;
						case 4: // enum
							{
								enum_t x(*mmaps[i]);
								x = atoi(slask);
								sprintf(sql + strlen(sql), "%s%s='%s'",
								 str, flds[i] -> name.c_str(), q.safestr(x.c_str()).c_str());
							}
							break;
						case 7: // set
							break;
					}
					strcpy(str, ", ");
				}
				strcat(sql, ")");

				lq.execute(sql);

			} // if (!ednr)
			ednr = 0;
		}
		ednr = 0;
	} // if "ed"


/*
 * page start
 */

	if (errcode)
		sprintf(errstr, "database error code %d<br>", errcode);

	header0("Edit data", 5, cs);
fflush(out);

	fprintf(out,"<table><tr><td valign=top>");
	fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>");
	fprintf(out,"<input type=hidden name=ed value=1>");
	fprintf(out,"<b>%s</b> :: Table ", sdb -> name.c_str());
	fprintf(out,"<select name=seltbl><option value=%ld>%s", stbl -> num, stbl -> name.c_str());
	sprintf(sql, "select num, name from tbls where dbnum=%ld and deleted=0 and num<>%ld", sdb -> num, stbl -> num);
	q.get_result(sql);
	while (q.fetch_row())
		fprintf(out,"<option value=%ld>%s", q.getval(0), q.getstr(1));
	q.free_result();
	fprintf(out,"</select>");
	fprintf(out,"<input type=submit name=submit value=\" Select table \">");
	fprintf(out,"</td><td valign=top>");
	fprintf(out,"<input type=submit name=submit value=\" Go back \">");
	fprintf(out,"</form>");
	fprintf(out,"</td></tr></table>");
fflush(out);

// navigate buttons up / down in data list

	sprintf(sql, "select max(%s) from %s", flds[0] -> name.c_str(), stbl -> name.c_str());
	maxnum = lqd -> get_count(sql);

	strcpy(slask, "[ ");
	if (stepnum > user -> steps)
	{
		fprintf(out,"%s<a href=/cgi-bin/dbd/dbd?stepnum=%ld>%ld..%ld</a> ", slask, stepnum - user -> steps, stepnum - user -> steps, stepnum - 1);
		strcpy(slask, "| ");
	}
	if (stepnum + user -> steps <= maxnum)
	{
		fprintf(out,"%s<a href=/cgi-bin/dbd/dbd?stepnum=%ld>%ld..%ld</a> ", slask, stepnum + user -> steps, stepnum + user -> steps, stepnum + user -> steps * 2 - 1);
		strcpy(slask, "| ");
	}
	if (*slask == '|')
		fprintf(out,"]<br>");
fflush(out);

	fprintf(out,"<table>");

// build query

	strcpy(slask, "select ");
	*sql = 0;
	for (i = 0; i < qty; i++)
	{
		sprintf(sql + strlen(sql), "%s%s", slask, flds[i] -> name.c_str());
		strcpy(slask, ", ");
	}
	sprintf(sql + strlen(sql), " from %s where %s>=%ld order by %s limit %ld",
	 stbl -> name.c_str(), flds[0] -> name.c_str(), stepnum, flds[0] -> name.c_str(), user -> steps);

// print header line

	fprintf(out,"<tr>");
	for (i = 0; i < qty; i++)
		fprintf(out,"<th align=left bgcolor=\"#e0e0e0\"><font size=\"-1\">%s</font></th>", flds[i] -> name.c_str());
	fprintf(out,"</tr>");


	if (form -> getvalue("ednr", slask, 20) && *slask)
		ednr = atol(slask);
	if (form -> getvalue("submit", slask, 200) && (!strcmp(slask, " Update ") || !strcmp(slask, " Delete ") || !strcmp(slask, " Cancel ")))
		ednr = 0;
	if (form -> getvalue("linknr", slask, 20) && *slask)
		linknr = atol(slask);
fflush(out);

	lq.get_result(sql);
	while (lq.fetch_row())
	{
		num = lq.getval(0);
		if (ednr == num || !ednr)
		{
			/*
			 * visa data
			 */
		 	visa_livedata(db, livedb, &lq, flds, qty, stbl, (ednr == num ? 1 : 0), a, user, vec);


		// visa data fran tabeller som pekar pa denna tabell
		if (num == linknr || ((user -> flags & UF_SHOWLINKED) != 0))
		{
			sprintf(sql, "select num from flds where ptrtotblnum=%ld order by tblnum", stbl -> num);
			q.get_result(sql);
			while (q.fetch_row())
			{
				l = q.getval();
				tempfld = new db::Flds(db, l); // fld i tabell som pekar pa aktuell tabell
				fromtbl = new db::Tbls(db, tempfld -> tblnum); // tabell som pekar pa aktuell tabell
				fld_v vec2;
				read_primary(db, q2, sql, fromtbl, vec2);
				sprintf(sql, "select num from flds where tblnum=%ld and deleted=0 order by ordning", fromtbl -> num);
				q2.get_result(sql);
				qflds = q2.num_rows();
				fromflds = new db::Flds *[qflds];
				j = 0;
				while (q2.fetch_row())
					fromflds[j++] = new db::Flds(db, q2.getval());
				q2.free_result();

				strcpy(slask, "select ");
				*sql = 0;
				l = -1;
				for (j = 0; j < qflds; j++)
				{
					sprintf(sql + strlen(sql), "%s%s", slask, fromflds[j] -> name.c_str());
					strcpy(slask, ", ");
					if (fromflds[j] -> num == tempfld -> num)
						l = j;
				}
				sprintf(sql + strlen(sql), " from %s where %s=%ld", fromtbl -> name.c_str(), tempfld -> name.c_str(), num);
				lq2.get_result(sql);
				while (lq2.fetch_row())
				{
				 	visa_livedata_sub(db, livedb, &lq2, fromflds, qflds, fromtbl -> name, l, stbl, 0, a, user, vec2);
				}
				lq2.free_result();

				// clean up
				for (fld_v::iterator it = vec2.begin(); it != vec2.end(); it++)
				{
					db::Flds *p = *it;
					delete p;
				}
				for (j = 0; j < qflds; j++)
					delete fromflds[j];
				delete fromflds;
				delete fromtbl;
				delete tempfld;
fflush(out);
			} // while
			q.free_result();
		} // if (user -> flags & UF_SHOWLINKED)

			if (ednr == num) // visa edit form
			{
				edit_livedata(db, livedb, q, lq2, sql, flds, mmaps, qty, ednr, lq, a);
			}
		} // ednr == num || !ednr
fflush(out);
	} // while
	lq.free_result();

//	fprintf(out,"<tr><td colspan=%ld><hr></td></tr>", qty);

	// insert form
	if (!ednr && a -> wdata)
	{
		fprintf(out,"<tr><td colspan=%ld>", qty);
		fprintf(out,"<h3>Insert new record</h3>");
		fprintf(out,"<form action=/cgi-bin/dbd/dbd method=post>");
		fprintf(out,"<input type=hidden name=ed value=1>");
		fprintf(out,"<input type=hidden name=ednr value=0>");
		fprintf(out,"<table>");
fflush(out);
		for (i = 0; i < qty; i++)
		{
			fprintf(out,"<tr>");
			switch (flds[i] -> fieldtype)
			{
				case 1: // char(x)
					fprintf(out,"<th class=edit align=right valign=top>%s</th>", flds[i] -> name.c_str());
					if (strstr(flds[i] -> fieldstr.c_str(), "BLOB"))
					{
						fprintf(out,"<td class=edit valign=top> ---- </td>");
					} 
					else
					if (strstr(flds[i] -> fieldstr.c_str(), "TEXT"))
					{
						fprintf(out,"<td class=edit valign=top><textarea name=%s rows=12 cols=80 wrap=off>", flds[i] -> name.c_str());
						fprintf(out,"</textarea></td>");
					} 
					else
					{
						fprintf(out,"<td class=edit valign=top><input type=text name=%s size=%ld></td>",
						 flds[i] -> name.c_str(), (flds[i] -> charlength < 80 ? flds[i] -> charlength + 1 : 80));
					}
					break;
				case 2: // int(x)
					fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
					if ((flds[i] -> fieldflags & FF_AUTO_INCREMENT) != 0)
					{
						fprintf(out,"<td class=edit> ---- </td>");
					}
					else
					{
						fprintf(out,"<td class=edit><input type=text name=%s size=%ld></td>",
						 flds[i] -> name.c_str(), flds[i] -> integerlength + 1);
					}
					break;
				case 3: // datetime
					fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
					fprintf(out,"<td class=edit><input type=text name=%s size=%d></td>",
					 flds[i] -> name.c_str(), 40);
					break;
				case 4: // enum
					fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
					fprintf(out,"<td class=edit><select name=%s>", flds[i] -> name.c_str());
					pa = new cgi::Parse( (char *)flds[i] -> options.c_str(), "/,");
					pa -> getword(slask);
					while (*slask)
					{
						if (name_ok(slask))
						{
							fprintf(out,"<option value=\"%s\">%s", slask, slask);
						}
						pa -> getword(slask);
					}
					delete pa;
					fprintf(out,"</select></td>");
					break;
				case 5: // ptrtotblnum
					fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
fflush(out);
					if (flds[i] -> ptrtotblnum)
					{
						totbl = new db::Tbls(db, flds[i] -> ptrtotblnum);
						sprintf(sql, "select num from flds where tblnum=%ld and deleted=0 order by ordning", totbl -> num);
						q.get_result(sql);
						qflds = q.num_rows();
						j = 0;
						while (q.fetch_row())
						{
							if (j < QTOFLDS)
								toflds[j] = new db::Flds(db, q.getval());
							j++;
						}
						q.free_result();
						while (j < QTOFLDS)
						{
							toflds[j++] = NULL;
						}

						fprintf(out,"<td class=edit><select name=%s><option value=0>", flds[i] -> name.c_str());
fflush(out);

						if (!toflds[1]) //qn == 1)
						{
							sprintf(sql, "select %s from %s order by %s",
							 toflds[0] -> name.c_str(), totbl -> name.c_str(), toflds[0] -> name.c_str());
						}
						else
						{
							sprintf(sql, "select %s, %s from %s order by %s",
							 toflds[0] -> name.c_str(), toflds[1] -> name.c_str(), totbl -> name.c_str(), toflds[0] -> name.c_str());
						}
						lq2.get_result(sql);
						while (lq2.fetch_row())
						{
							if (!toflds[1]) //qn == 1)
							{
								fprintf(out,"<option>%s", lq2.getstr());
							}
							else
							{
								fprintf(out,"<option value=%s>%s / %s",
								 lq2.getstr(0), lq2.getstr(0), lq2.getstr(1));
							}
fflush(out);
						}
						lq2.free_result();

						fprintf(out,"</select></td>");
fflush(out);

						// delete to table stuff
						for (j = 0; j < qflds; j++)
						{
							if (j < QTOFLDS && toflds[j])
							{
								delete toflds[j];
							}
						}
						delete totbl;
					} 
					else
					{
						fprintf(out,"<td class=edit></td>");
					}
fflush(out);
					break;
				case 6: // number
					fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
					fprintf(out,"<td class=edit><input type=text name=%s size=%ld></td>",
					 flds[i] -> name.c_str(), flds[i] -> integerlength + flds[i] -> decimallength + 1);
					break;
				case 7: // set
					fprintf(out,"<th class=edit align=right>%s</th>", flds[i] -> name.c_str());
					fprintf(out,"<td class=edit>");
					{
						set_t x(*mmaps[i]);
						for (enumset_m::iterator it = mmaps[i] -> begin(); it != mmaps[i] -> end(); it++)
						{
							std::string str = (*it).first;
							uint64_t bit = (*it).second;
							if (bit)
							{
								fprintf(out,"<span class=enum><input type=checkbox name=%s value=%lld%s>",
									flds[i] -> name.c_str(),bit,(x.Value() & bit) ? " CHECKED" : "");
								fprintf(out,"%s&nbsp;</span>",str.c_str());
							}
						}
					}
					fprintf(out,"</td>");
					break;
			}
			fprintf(out,"</tr>");
fflush(out);
		} // for
		fprintf(out,"<tr><td class=edit colspan=2 align=center>");
		fprintf(out,"<input type=submit name=submit value=\" Insert \">");
		fprintf(out,"</td></tr></table>");
		fprintf(out,"</form>");
		fprintf(out,"</td></tr>");
	}
	fprintf(out,"</table>");
fflush(out);
	footer();

	// clean up
	for (fld_v::iterator it = vec.begin(); it != vec.end(); it++)
	{
		db::Flds *p = *it;
		delete p;
	}

	for (i = 0; i < qty; i++)
	{
		delete flds[i];
		if (mmaps[i])
		{
			delete mmaps[i];
		}
	}
	delete sql;
	delete flds;
	delete mmaps;
	delete lqd;
}
