// purge.cpp
/*
Copyright (C) 2001-2004  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql/mysql.h>
#include <libmysqlwrapped.h>
#include <string.h>
#include <libdbd.h>


int main(int argc,char *argv[])
{
	Database db("localhost","root","","dbd");
	Query q(db),q2(db),*qd = new Query(db);
	db::Dbs *sdb;
	db::Tbls *stbl;
	db::Flds *sfld;
	long dbnum;
	long owner;
	long num;
	char sql[999];
	char dbname[40];
	char handle[40];

	if (argc == 5)
	{
		dbnum = atol(argv[1]);
		strcpy(dbname,argv[2]);
		owner = atol(argv[3]);
		strcpy(handle,argv[4]);

		sprintf(sql,"select num from dbs where num=%ld and name='%s' and owner=%ld",dbnum,dbname,owner);
		num = qd -> get_count(sql);
		sprintf(sql,"select handle from users where num=%ld",owner);
		if (!strcmp(handle,qd -> get_string(sql)) && num == dbnum)
		{
			sdb = new db::Dbs(db,dbnum);
			printf("Purging dbd records for database '%s' - Please drop database manually\n",sdb -> name.c_str());
			sprintf(sql,"select num from tbls where dbnum=%ld",sdb -> num);
			q.get_result(sql);
			while (q.fetch_row())
			{
				stbl = new db::Tbls(db,q.getval(0));
				sprintf(sql,"select num from flds where tblnum=%ld",stbl -> num);
				q2.get_result(sql);
				while (q2.fetch_row())
				{
					sfld = new db::Flds(db,q2.getval(0));
					sprintf(sql,"delete from kommentar where fldnum=%ld",sfld -> num);
					qd -> execute(sql);
					delete sfld;
				}
				q2.free_result();
				sprintf(sql,"delete from kommentar where tblnum=%ld",stbl -> num);
				qd -> execute(sql);
				sprintf(sql,"delete from flds where tblnum=%ld",stbl -> num);
				qd -> execute(sql);
				delete stbl;
			}
			q.free_result();
			sprintf(sql,"delete from kommentar where dbnum=%ld",sdb -> num);
			qd -> execute(sql);
			sprintf(sql,"delete from tbls where dbnum=%ld",sdb -> num);
			qd -> execute(sql);
			delete sdb;
			sprintf(sql,"delete from dbs where num=%ld",dbnum);
			qd -> execute(sql);
		}
	} else
	{
		printf("Usage: %s <databasenum> <databasename> <ownernum> <ownerhandle>\n",*argv);
		printf(" Current databases stored:\n");
		sprintf(sql,"select num,name,owner from dbs order by name");
		q.get_result(sql);
		while (q.fetch_row())
		{
			sprintf(sql,"select handle from users where num=%ld",q.getval(2));
			printf("%8ld '%s' owner is #%ld '%s'\n",
			 q.getval(0),q.getstr(1),q.getval(2),qd -> get_string(sql));
		}
		q.free_result();
	}
	
	delete qd;
}
