/*
 *	 /usr/devel/src/libdbd/libdbd.cpp
 *	 Generated by sql2class by (C) AH 2000
 *	 Tue Oct 12 08:43:39 2004
 */

/*
Copyright (C) 2001  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <libdbd.h>

namespace db {

/**
 **  Begin class 'Access'
 **/

Access::Access(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Access::Access(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Access::Access(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Access::Access(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from access where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Access::~Access()
{
}


void Access::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Access::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into access(num,usernum,dbnum,r,w,c,d,rdata,wdata)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> usernum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> dbnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> r);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> w);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> c);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> d);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> rdata);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> wdata);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Access::update()
{
	update(this -> num);
}


void Access::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update access set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", usernum=%ld",this -> usernum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", dbnum=%ld",this -> dbnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", r=%d",this -> r);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", w=%d",this -> w);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", c=%d",this -> c);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", d=%d",this -> d);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", rdata=%d",this -> rdata);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", wdata=%d",this -> wdata);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Access::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Access::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from access where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Access::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<ACCESS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	sprintf(slask,"<R>%d</R>",this -> r);
	dest += slask;
	sprintf(slask,"<W>%d</W>",this -> w);
	dest += slask;
	sprintf(slask,"<C>%d</C>",this -> c);
	dest += slask;
	sprintf(slask,"<D>%d</D>",this -> d);
	dest += slask;
	sprintf(slask,"<RDATA>%d</RDATA>",this -> rdata);
	dest += slask;
	sprintf(slask,"<WDATA>%d</WDATA>",this -> wdata);
	dest += slask;
	dest += "</ACCESS>";
	return dest;
}


std::string Access::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<ACCESS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	sprintf(slask,"<R>%d</R>",this -> r);
	dest += slask;
	sprintf(slask,"<W>%d</W>",this -> w);
	dest += slask;
	sprintf(slask,"<C>%d</C>",this -> c);
	dest += slask;
	sprintf(slask,"<D>%d</D>",this -> d);
	dest += slask;
	sprintf(slask,"<RDATA>%d</RDATA>",this -> rdata);
	dest += slask;
	sprintf(slask,"<WDATA>%d</WDATA>",this -> wdata);
	dest += slask;
	dest += "</ACCESS>";
	return dest;
}


size_t Access::num_cols()
{
	return 9;
}


void Access::clear()
{
	num = 0;
	usernum = 0;
	dbnum = 0;
	r = 0;
	w = 0;
	c = 0;
	d = 0;
	rdata = 0;
	wdata = 0;
}


void Access::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,usernum,dbnum,r,w,c,d,rdata,wdata " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		usernum = q.getval(1);                                // 1 - usernum int(11)
		dbnum = q.getval(2);                                  // 2 - dbnum int(11)
		r = q.getval(3);                                      // 3 - r tinyint(1)
		w = q.getval(4);                                      // 4 - w tinyint(1)
		c = q.getval(5);                                      // 5 - c tinyint(1)
		d = q.getval(6);                                      // 6 - d tinyint(1)
		rdata = q.getval(7);                                  // 7 - rdata tinyint(1)
		wdata = q.getval(8);                                  // 8 - wdata tinyint(1)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Access::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	usernum = qd -> getval(1);                                // 1 - usernum int(11)
	dbnum = qd -> getval(2);                                  // 2 - dbnum int(11)
	r = qd -> getval(3);                                      // 3 - r tinyint(1)
	w = qd -> getval(4);                                      // 4 - w tinyint(1)
	c = qd -> getval(5);                                      // 5 - c tinyint(1)
	d = qd -> getval(6);                                      // 6 - d tinyint(1)
	rdata = qd -> getval(7);                                  // 7 - rdata tinyint(1)
	wdata = qd -> getval(8);                                  // 8 - wdata tinyint(1)
}


// End of implementation of class 'Access'

} // End of namespace
namespace db {

/**
 **  Begin class 'Appfields'
 **/

Appfields::Appfields(Database *db):status(mmap_status)
{
	database = db;
	new_object = 1;
	clear();
}


Appfields::Appfields(Database *db,const std::string& sql):status(mmap_status)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Appfields::Appfields(Database *db,Query *qd):status(mmap_status)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Appfields::Appfields(Database& db,long i_num):status(mmap_status),database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from appfields where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Appfields::~Appfields()
{
}


void Appfields::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Appfields::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into appfields(num,appnum,fldnum,status,tblnum)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> appnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> fldnum);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> status.String()) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> tblnum);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Appfields::update()
{
	update(this -> num);
}


void Appfields::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update appfields set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", appnum=%ld",this -> appnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", fldnum=%ld",this -> fldnum);
		sql += slask;
	}
	sql += ", status='" + q.safestr(this -> status.String()) + "'";
	{
		char slask[200];
		sprintf(slask,", tblnum=%ld",this -> tblnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Appfields::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Appfields::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from appfields where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Appfields::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<APPFIELDS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<APPNUM>%ld</APPNUM>",this -> appnum);
	dest += slask;
	sprintf(slask,"<FLDNUM>%ld</FLDNUM>",this -> fldnum);
	dest += slask;
	dest += "<STATUS>" + q.xmlsafestr(this -> status.String()) + "</STATUS>";
	sprintf(slask,"<TBLNUM>%ld</TBLNUM>",this -> tblnum);
	dest += slask;
	dest += "</APPFIELDS>";
	return dest;
}


std::string Appfields::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<APPFIELDS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<APPNUM>%ld</APPNUM>",this -> appnum);
	dest += slask;
	sprintf(slask,"<FLDNUM>%ld</FLDNUM>",this -> fldnum);
	dest += slask;
	dest += "<STATUS>" + q.xmlsafestr(this -> status.String()) + "</STATUS>";
	sprintf(slask,"<TBLNUM>%ld</TBLNUM>",this -> tblnum);
	dest += slask;
	dest += "</APPFIELDS>";
	return dest;
}


size_t Appfields::num_cols()
{
	return 5;
}


void Appfields::clear()
{
	mmap_status["Planned"] = 1;
	mmap_status["Implemented"] = 2;
	mmap_status["Hold"] = 3;
	num = 0;
	appnum = 0;
	fldnum = 0;
	// 3 - status enum('Planned','Implemented','Hold')
	tblnum = 0;
}


void Appfields::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,appnum,fldnum,status,tblnum " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		appnum = q.getval(1);                                 // 1 - appnum int(11)
		fldnum = q.getval(2);                                 // 2 - fldnum int(11)
		status = q.getstr(3);                                 // 3 - status enum('Planned','Implemented','Hold')
		tblnum = q.getval(4);                                 // 4 - tblnum int(11)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Appfields::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	appnum = qd -> getval(1);                                 // 1 - appnum int(11)
	fldnum = qd -> getval(2);                                 // 2 - fldnum int(11)
	status = qd -> getstr(3);                                 // 3 - status enum('Planned','Implemented','Hold')
	tblnum = qd -> getval(4);                                 // 4 - tblnum int(11)
}


// End of implementation of class 'Appfields'

} // End of namespace
namespace db {

/**
 **  Begin class 'Applications'
 **/

Applications::Applications(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Applications::Applications(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Applications::Applications(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Applications::Applications(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from applications where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Applications::~Applications()
{
}


void Applications::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Applications::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into applications(num,owner,createdate,changedby,changedate,deleted,deletedby,deletedate,name,version,dbnum,description)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> owner);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> createdate) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> changedby);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> changedate) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> deleted);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> deletedby);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> deletedate) + "'";
	sql += ", '" + q.safestr(this -> name) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> version);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> dbnum);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> description) + "'";
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Applications::update()
{
	update(this -> num);
}


void Applications::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update applications set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", owner=%ld",this -> owner);
		sql += slask;
	}
	sql += ", createdate='" + q.safestr(this -> createdate) + "'";
	{
		char slask[200];
		sprintf(slask,", changedby=%ld",this -> changedby);
		sql += slask;
	}
	sql += ", changedate='" + q.safestr(this -> changedate) + "'";
	{
		char slask[200];
		sprintf(slask,", deleted=%d",this -> deleted);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", deletedby=%ld",this -> deletedby);
		sql += slask;
	}
	sql += ", deletedate='" + q.safestr(this -> deletedate) + "'";
	sql += ", name='" + q.safestr(this -> name) + "'";
	{
		char slask[200];
		sprintf(slask,", version=%ld",this -> version);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", dbnum=%ld",this -> dbnum);
		sql += slask;
	}
	sql += ", description='" + q.safestr(this -> description) + "'";
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Applications::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Applications::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from applications where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Applications::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<APPLICATIONS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<OWNER>%ld</OWNER>",this -> owner);
	dest += slask;
	dest += "<CREATEDATE>" + q.xmlsafestr(this -> createdate) + "</CREATEDATE>";
	sprintf(slask,"<CHANGEDBY>%ld</CHANGEDBY>",this -> changedby);
	dest += slask;
	dest += "<CHANGEDATE>" + q.xmlsafestr(this -> changedate) + "</CHANGEDATE>";
	sprintf(slask,"<DELETED>%d</DELETED>",this -> deleted);
	dest += slask;
	sprintf(slask,"<DELETEDBY>%ld</DELETEDBY>",this -> deletedby);
	dest += slask;
	dest += "<DELETEDATE>" + q.xmlsafestr(this -> deletedate) + "</DELETEDATE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<VERSION>%ld</VERSION>",this -> version);
	dest += slask;
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	dest += "<DESCRIPTION>" + q.xmlsafestr(this -> description) + "</DESCRIPTION>";
	dest += "</APPLICATIONS>";
	return dest;
}


std::string Applications::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<APPLICATIONS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<OWNER>%ld</OWNER>",this -> owner);
	dest += slask;
	dest += "<CREATEDATE>" + q.xmlsafestr(this -> createdate) + "</CREATEDATE>";
	sprintf(slask,"<CHANGEDBY>%ld</CHANGEDBY>",this -> changedby);
	dest += slask;
	dest += "<CHANGEDATE>" + q.xmlsafestr(this -> changedate) + "</CHANGEDATE>";
	sprintf(slask,"<DELETED>%d</DELETED>",this -> deleted);
	dest += slask;
	sprintf(slask,"<DELETEDBY>%ld</DELETEDBY>",this -> deletedby);
	dest += slask;
	dest += "<DELETEDATE>" + q.xmlsafestr(this -> deletedate) + "</DELETEDATE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<VERSION>%ld</VERSION>",this -> version);
	dest += slask;
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	dest += "<DESCRIPTION>" + q.xmlsafestr(this -> description) + "</DESCRIPTION>";
	dest += "</APPLICATIONS>";
	return dest;
}


size_t Applications::num_cols()
{
	return 12;
}


void Applications::clear()
{
	num = 0;
	owner = 0;
	// 2 - createdate datetime
	changedby = 0;
	// 4 - changedate datetime
	deleted = 0;
	deletedby = 0;
	// 7 - deletedate datetime
	// 8 - name char(40)
	version = 0;
	dbnum = 0;
	// 11 - description char(40)
}


void Applications::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,owner,createdate,changedby,changedate,deleted,deletedby,deletedate,name,version,dbnum,description " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		owner = q.getval(1);                                  // 1 - owner int(11)
		createdate = q.getstr(2);                             // 2 - createdate datetime
		changedby = q.getval(3);                              // 3 - changedby int(11)
		changedate = q.getstr(4);                             // 4 - changedate datetime
		deleted = q.getval(5);                                // 5 - deleted tinyint(1)
		deletedby = q.getval(6);                              // 6 - deletedby int(11)
		deletedate = q.getstr(7);                             // 7 - deletedate datetime
		name = q.getstr(8);                                   // 8 - name char(40)
		version = q.getval(9);                                // 9 - version int(11)
		dbnum = q.getval(10);                                 // 10 - dbnum int(11)
		description = q.getstr(11);                           // 11 - description char(40)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Applications::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	owner = qd -> getval(1);                                  // 1 - owner int(11)
	createdate = qd -> getstr(2);                             // 2 - createdate datetime
	changedby = qd -> getval(3);                              // 3 - changedby int(11)
	changedate = qd -> getstr(4);                             // 4 - changedate datetime
	deleted = qd -> getval(5);                                // 5 - deleted tinyint(1)
	deletedby = qd -> getval(6);                              // 6 - deletedby int(11)
	deletedate = qd -> getstr(7);                             // 7 - deletedate datetime
	name = qd -> getstr(8);                                   // 8 - name char(40)
	version = qd -> getval(9);                                // 9 - version int(11)
	dbnum = qd -> getval(10);                                 // 10 - dbnum int(11)
	description = qd -> getstr(11);                           // 11 - description char(40)
}


// End of implementation of class 'Applications'

} // End of namespace
namespace db {

/**
 **  Begin class 'Apptables'
 **/

Apptables::Apptables(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Apptables::Apptables(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Apptables::Apptables(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Apptables::Apptables(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from apptables where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Apptables::~Apptables()
{
}


void Apptables::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Apptables::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into apptables(num,appnum,tblnum,checked)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> appnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> tblnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> checked);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Apptables::update()
{
	update(this -> num);
}


void Apptables::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update apptables set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", appnum=%ld",this -> appnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", tblnum=%ld",this -> tblnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", checked=%d",this -> checked);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Apptables::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Apptables::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from apptables where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Apptables::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<APPTABLES>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<APPNUM>%ld</APPNUM>",this -> appnum);
	dest += slask;
	sprintf(slask,"<TBLNUM>%ld</TBLNUM>",this -> tblnum);
	dest += slask;
	sprintf(slask,"<CHECKED>%d</CHECKED>",this -> checked);
	dest += slask;
	dest += "</APPTABLES>";
	return dest;
}


std::string Apptables::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<APPTABLES " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<APPNUM>%ld</APPNUM>",this -> appnum);
	dest += slask;
	sprintf(slask,"<TBLNUM>%ld</TBLNUM>",this -> tblnum);
	dest += slask;
	sprintf(slask,"<CHECKED>%d</CHECKED>",this -> checked);
	dest += slask;
	dest += "</APPTABLES>";
	return dest;
}


size_t Apptables::num_cols()
{
	return 4;
}


void Apptables::clear()
{
	num = 0;
	appnum = 0;
	tblnum = 0;
	checked = 0;
}


void Apptables::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,appnum,tblnum,checked " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		appnum = q.getval(1);                                 // 1 - appnum int(11)
		tblnum = q.getval(2);                                 // 2 - tblnum int(11)
		checked = q.getval(3);                                // 3 - checked tinyint(1)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Apptables::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	appnum = qd -> getval(1);                                 // 1 - appnum int(11)
	tblnum = qd -> getval(2);                                 // 2 - tblnum int(11)
	checked = qd -> getval(3);                                // 3 - checked tinyint(1)
}


// End of implementation of class 'Apptables'

} // End of namespace
namespace db {

/**
 **  Begin class 'Appusers'
 **/

Appusers::Appusers(Database *db):status(mmap_status)
{
	database = db;
	new_object = 1;
	clear();
}


Appusers::Appusers(Database *db,const std::string& sql):status(mmap_status)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Appusers::Appusers(Database *db,Query *qd):status(mmap_status)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Appusers::Appusers(Database& db,long i_num):status(mmap_status),database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from appusers where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Appusers::~Appusers()
{
}


void Appusers::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Appusers::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into appusers(num,appnum,usernum,status)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> appnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> usernum);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> status.String()) + "'";
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Appusers::update()
{
	update(this -> num);
}


void Appusers::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update appusers set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", appnum=%ld",this -> appnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", usernum=%ld",this -> usernum);
		sql += slask;
	}
	sql += ", status='" + q.safestr(this -> status.String()) + "'";
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Appusers::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Appusers::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from appusers where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Appusers::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<APPUSERS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<APPNUM>%ld</APPNUM>",this -> appnum);
	dest += slask;
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	dest += "<STATUS>" + q.xmlsafestr(this -> status.String()) + "</STATUS>";
	dest += "</APPUSERS>";
	return dest;
}


std::string Appusers::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<APPUSERS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<APPNUM>%ld</APPNUM>",this -> appnum);
	dest += slask;
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	dest += "<STATUS>" + q.xmlsafestr(this -> status.String()) + "</STATUS>";
	dest += "</APPUSERS>";
	return dest;
}


size_t Appusers::num_cols()
{
	return 4;
}


void Appusers::clear()
{
	mmap_status["Developer"] = 1;
	mmap_status["Tester"] = 2;
	num = 0;
	appnum = 0;
	usernum = 0;
	// 3 - status enum('Developer','Tester')
}


void Appusers::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,appnum,usernum,status " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		appnum = q.getval(1);                                 // 1 - appnum int(11)
		usernum = q.getval(2);                                // 2 - usernum int(11)
		status = q.getstr(3);                                 // 3 - status enum('Developer','Tester')
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Appusers::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	appnum = qd -> getval(1);                                 // 1 - appnum int(11)
	usernum = qd -> getval(2);                                // 2 - usernum int(11)
	status = qd -> getstr(3);                                 // 3 - status enum('Developer','Tester')
}


// End of implementation of class 'Appusers'

} // End of namespace
namespace db {

/**
 **  Begin class 'Dbs'
 **/

Dbs::Dbs(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Dbs::Dbs(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Dbs::Dbs(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Dbs::Dbs(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from dbs where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Dbs::~Dbs()
{
}


void Dbs::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Dbs::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into dbs(num,owner,createdate,changedby,changedate,deleted,deletedby,deletedate,name,version,description)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> owner);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> createdate) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> changedby);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> changedate) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> deleted);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> deletedby);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> deletedate) + "'";
	sql += ", '" + q.safestr(this -> name) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> version);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> description) + "'";
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Dbs::update()
{
	update(this -> num);
}


void Dbs::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update dbs set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", owner=%ld",this -> owner);
		sql += slask;
	}
	sql += ", createdate='" + q.safestr(this -> createdate) + "'";
	{
		char slask[200];
		sprintf(slask,", changedby=%ld",this -> changedby);
		sql += slask;
	}
	sql += ", changedate='" + q.safestr(this -> changedate) + "'";
	{
		char slask[200];
		sprintf(slask,", deleted=%d",this -> deleted);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", deletedby=%ld",this -> deletedby);
		sql += slask;
	}
	sql += ", deletedate='" + q.safestr(this -> deletedate) + "'";
	sql += ", name='" + q.safestr(this -> name) + "'";
	{
		char slask[200];
		sprintf(slask,", version=%ld",this -> version);
		sql += slask;
	}
	sql += ", description='" + q.safestr(this -> description) + "'";
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Dbs::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Dbs::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from dbs where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Dbs::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<DBS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<OWNER>%ld</OWNER>",this -> owner);
	dest += slask;
	dest += "<CREATEDATE>" + q.xmlsafestr(this -> createdate) + "</CREATEDATE>";
	sprintf(slask,"<CHANGEDBY>%ld</CHANGEDBY>",this -> changedby);
	dest += slask;
	dest += "<CHANGEDATE>" + q.xmlsafestr(this -> changedate) + "</CHANGEDATE>";
	sprintf(slask,"<DELETED>%d</DELETED>",this -> deleted);
	dest += slask;
	sprintf(slask,"<DELETEDBY>%ld</DELETEDBY>",this -> deletedby);
	dest += slask;
	dest += "<DELETEDATE>" + q.xmlsafestr(this -> deletedate) + "</DELETEDATE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<VERSION>%ld</VERSION>",this -> version);
	dest += slask;
	dest += "<DESCRIPTION>" + q.xmlsafestr(this -> description) + "</DESCRIPTION>";
	dest += "</DBS>";
	return dest;
}


std::string Dbs::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<DBS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<OWNER>%ld</OWNER>",this -> owner);
	dest += slask;
	dest += "<CREATEDATE>" + q.xmlsafestr(this -> createdate) + "</CREATEDATE>";
	sprintf(slask,"<CHANGEDBY>%ld</CHANGEDBY>",this -> changedby);
	dest += slask;
	dest += "<CHANGEDATE>" + q.xmlsafestr(this -> changedate) + "</CHANGEDATE>";
	sprintf(slask,"<DELETED>%d</DELETED>",this -> deleted);
	dest += slask;
	sprintf(slask,"<DELETEDBY>%ld</DELETEDBY>",this -> deletedby);
	dest += slask;
	dest += "<DELETEDATE>" + q.xmlsafestr(this -> deletedate) + "</DELETEDATE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<VERSION>%ld</VERSION>",this -> version);
	dest += slask;
	dest += "<DESCRIPTION>" + q.xmlsafestr(this -> description) + "</DESCRIPTION>";
	dest += "</DBS>";
	return dest;
}


size_t Dbs::num_cols()
{
	return 11;
}


void Dbs::clear()
{
	num = 0;
	owner = 0;
	// 2 - createdate datetime
	changedby = 0;
	// 4 - changedate datetime
	deleted = 0;
	deletedby = 0;
	// 7 - deletedate datetime
	// 8 - name char(40)
	version = 0;
	// 10 - description char(80)
}


void Dbs::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,owner,createdate,changedby,changedate,deleted,deletedby,deletedate,name,version,description " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		owner = q.getval(1);                                  // 1 - owner int(11)
		createdate = q.getstr(2);                             // 2 - createdate datetime
		changedby = q.getval(3);                              // 3 - changedby int(11)
		changedate = q.getstr(4);                             // 4 - changedate datetime
		deleted = q.getval(5);                                // 5 - deleted tinyint(1)
		deletedby = q.getval(6);                              // 6 - deletedby int(11)
		deletedate = q.getstr(7);                             // 7 - deletedate datetime
		name = q.getstr(8);                                   // 8 - name char(40)
		version = q.getval(9);                                // 9 - version int(11)
		description = q.getstr(10);                           // 10 - description char(80)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Dbs::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	owner = qd -> getval(1);                                  // 1 - owner int(11)
	createdate = qd -> getstr(2);                             // 2 - createdate datetime
	changedby = qd -> getval(3);                              // 3 - changedby int(11)
	changedate = qd -> getstr(4);                             // 4 - changedate datetime
	deleted = qd -> getval(5);                                // 5 - deleted tinyint(1)
	deletedby = qd -> getval(6);                              // 6 - deletedby int(11)
	deletedate = qd -> getstr(7);                             // 7 - deletedate datetime
	name = qd -> getstr(8);                                   // 8 - name char(40)
	version = qd -> getval(9);                                // 9 - version int(11)
	description = qd -> getstr(10);                           // 10 - description char(80)
}


// End of implementation of class 'Dbs'

} // End of namespace
namespace db {

/**
 **  Begin class 'Flds'
 **/

Flds::Flds(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Flds::Flds(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Flds::Flds(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Flds::Flds(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from flds where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Flds::~Flds()
{
}


void Flds::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Flds::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into flds(num,tblnum,owner,createdate,changedby,changedate,deleted,deletedby,deletedate,name,version,fieldtype,charlength,minvalue,maxvalue,options,ptrtotblnum,ordning,integerlength,description,fieldstr,fieldflags,decimallength,defaultvalue)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> tblnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> owner);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> createdate) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> changedby);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> changedate) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> deleted);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> deletedby);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> deletedate) + "'";
	sql += ", '" + q.safestr(this -> name) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> version);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %d",this -> fieldtype);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> charlength);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> minvalue);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> maxvalue);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> options) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> ptrtotblnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> ordning);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> integerlength);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> description) + "'";
	sql += ", '" + q.safestr(this -> fieldstr) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> fieldflags);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> decimallength);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> defaultvalue) + "'";
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Flds::update()
{
	update(this -> num);
}


void Flds::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update flds set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", tblnum=%ld",this -> tblnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", owner=%ld",this -> owner);
		sql += slask;
	}
	sql += ", createdate='" + q.safestr(this -> createdate) + "'";
	{
		char slask[200];
		sprintf(slask,", changedby=%ld",this -> changedby);
		sql += slask;
	}
	sql += ", changedate='" + q.safestr(this -> changedate) + "'";
	{
		char slask[200];
		sprintf(slask,", deleted=%d",this -> deleted);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", deletedby=%ld",this -> deletedby);
		sql += slask;
	}
	sql += ", deletedate='" + q.safestr(this -> deletedate) + "'";
	sql += ", name='" + q.safestr(this -> name) + "'";
	{
		char slask[200];
		sprintf(slask,", version=%ld",this -> version);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", fieldtype=%d",this -> fieldtype);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", charlength=%ld",this -> charlength);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", minvalue=%ld",this -> minvalue);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", maxvalue=%ld",this -> maxvalue);
		sql += slask;
	}
	sql += ", options='" + q.safestr(this -> options) + "'";
	{
		char slask[200];
		sprintf(slask,", ptrtotblnum=%ld",this -> ptrtotblnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", ordning=%ld",this -> ordning);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", integerlength=%ld",this -> integerlength);
		sql += slask;
	}
	sql += ", description='" + q.safestr(this -> description) + "'";
	sql += ", fieldstr='" + q.safestr(this -> fieldstr) + "'";
	{
		char slask[200];
		sprintf(slask,", fieldflags=%d",this -> fieldflags);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", decimallength=%ld",this -> decimallength);
		sql += slask;
	}
	sql += ", defaultvalue='" + q.safestr(this -> defaultvalue) + "'";
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Flds::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Flds::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from flds where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Flds::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<FLDS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<TBLNUM>%ld</TBLNUM>",this -> tblnum);
	dest += slask;
	sprintf(slask,"<OWNER>%ld</OWNER>",this -> owner);
	dest += slask;
	dest += "<CREATEDATE>" + q.xmlsafestr(this -> createdate) + "</CREATEDATE>";
	sprintf(slask,"<CHANGEDBY>%ld</CHANGEDBY>",this -> changedby);
	dest += slask;
	dest += "<CHANGEDATE>" + q.xmlsafestr(this -> changedate) + "</CHANGEDATE>";
	sprintf(slask,"<DELETED>%d</DELETED>",this -> deleted);
	dest += slask;
	sprintf(slask,"<DELETEDBY>%ld</DELETEDBY>",this -> deletedby);
	dest += slask;
	dest += "<DELETEDATE>" + q.xmlsafestr(this -> deletedate) + "</DELETEDATE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<VERSION>%ld</VERSION>",this -> version);
	dest += slask;
	sprintf(slask,"<FIELDTYPE>%d</FIELDTYPE>",this -> fieldtype);
	dest += slask;
	sprintf(slask,"<CHARLENGTH>%ld</CHARLENGTH>",this -> charlength);
	dest += slask;
	sprintf(slask,"<MINVALUE>%ld</MINVALUE>",this -> minvalue);
	dest += slask;
	sprintf(slask,"<MAXVALUE>%ld</MAXVALUE>",this -> maxvalue);
	dest += slask;
	dest += "<OPTIONS>" + q.xmlsafestr(this -> options) + "</OPTIONS>";
	sprintf(slask,"<PTRTOTBLNUM>%ld</PTRTOTBLNUM>",this -> ptrtotblnum);
	dest += slask;
	sprintf(slask,"<ORDNING>%ld</ORDNING>",this -> ordning);
	dest += slask;
	sprintf(slask,"<INTEGERLENGTH>%ld</INTEGERLENGTH>",this -> integerlength);
	dest += slask;
	dest += "<DESCRIPTION>" + q.xmlsafestr(this -> description) + "</DESCRIPTION>";
	dest += "<FIELDSTR>" + q.xmlsafestr(this -> fieldstr) + "</FIELDSTR>";
	sprintf(slask,"<FIELDFLAGS>%d</FIELDFLAGS>",this -> fieldflags);
	dest += slask;
	sprintf(slask,"<DECIMALLENGTH>%ld</DECIMALLENGTH>",this -> decimallength);
	dest += slask;
	dest += "<DEFAULTVALUE>" + q.xmlsafestr(this -> defaultvalue) + "</DEFAULTVALUE>";
	dest += "</FLDS>";
	return dest;
}


std::string Flds::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<FLDS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<TBLNUM>%ld</TBLNUM>",this -> tblnum);
	dest += slask;
	sprintf(slask,"<OWNER>%ld</OWNER>",this -> owner);
	dest += slask;
	dest += "<CREATEDATE>" + q.xmlsafestr(this -> createdate) + "</CREATEDATE>";
	sprintf(slask,"<CHANGEDBY>%ld</CHANGEDBY>",this -> changedby);
	dest += slask;
	dest += "<CHANGEDATE>" + q.xmlsafestr(this -> changedate) + "</CHANGEDATE>";
	sprintf(slask,"<DELETED>%d</DELETED>",this -> deleted);
	dest += slask;
	sprintf(slask,"<DELETEDBY>%ld</DELETEDBY>",this -> deletedby);
	dest += slask;
	dest += "<DELETEDATE>" + q.xmlsafestr(this -> deletedate) + "</DELETEDATE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<VERSION>%ld</VERSION>",this -> version);
	dest += slask;
	sprintf(slask,"<FIELDTYPE>%d</FIELDTYPE>",this -> fieldtype);
	dest += slask;
	sprintf(slask,"<CHARLENGTH>%ld</CHARLENGTH>",this -> charlength);
	dest += slask;
	sprintf(slask,"<MINVALUE>%ld</MINVALUE>",this -> minvalue);
	dest += slask;
	sprintf(slask,"<MAXVALUE>%ld</MAXVALUE>",this -> maxvalue);
	dest += slask;
	dest += "<OPTIONS>" + q.xmlsafestr(this -> options) + "</OPTIONS>";
	sprintf(slask,"<PTRTOTBLNUM>%ld</PTRTOTBLNUM>",this -> ptrtotblnum);
	dest += slask;
	sprintf(slask,"<ORDNING>%ld</ORDNING>",this -> ordning);
	dest += slask;
	sprintf(slask,"<INTEGERLENGTH>%ld</INTEGERLENGTH>",this -> integerlength);
	dest += slask;
	dest += "<DESCRIPTION>" + q.xmlsafestr(this -> description) + "</DESCRIPTION>";
	dest += "<FIELDSTR>" + q.xmlsafestr(this -> fieldstr) + "</FIELDSTR>";
	sprintf(slask,"<FIELDFLAGS>%d</FIELDFLAGS>",this -> fieldflags);
	dest += slask;
	sprintf(slask,"<DECIMALLENGTH>%ld</DECIMALLENGTH>",this -> decimallength);
	dest += slask;
	dest += "<DEFAULTVALUE>" + q.xmlsafestr(this -> defaultvalue) + "</DEFAULTVALUE>";
	dest += "</FLDS>";
	return dest;
}


size_t Flds::num_cols()
{
	return 24;
}


void Flds::clear()
{
	num = 0;
	tblnum = 0;
	owner = 0;
	// 3 - createdate datetime
	changedby = 0;
	// 5 - changedate datetime
	deleted = 0;
	deletedby = 0;
	// 8 - deletedate datetime
	// 9 - name varchar(40)
	version = 0;
	fieldtype = 0;
	charlength = 0;
	minvalue = 0;
	maxvalue = 0;
	// 15 - options text
	ptrtotblnum = 0;
	ordning = 0;
	integerlength = 0;
	// 19 - description varchar(80)
	// 20 - fieldstr varchar(20)
	fieldflags = 0;
	decimallength = 0;
	// 23 - defaultvalue varchar(40)
}


void Flds::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,tblnum,owner,createdate,changedby,changedate,deleted,deletedby,deletedate,name,version,fieldtype,charlength,minvalue,maxvalue,options,ptrtotblnum,ordning,integerlength,description,fieldstr,fieldflags,decimallength,defaultvalue " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		tblnum = q.getval(1);                                 // 1 - tblnum int(11)
		owner = q.getval(2);                                  // 2 - owner int(11)
		createdate = q.getstr(3);                             // 3 - createdate datetime
		changedby = q.getval(4);                              // 4 - changedby int(11)
		changedate = q.getstr(5);                             // 5 - changedate datetime
		deleted = q.getval(6);                                // 6 - deleted tinyint(1)
		deletedby = q.getval(7);                              // 7 - deletedby int(11)
		deletedate = q.getstr(8);                             // 8 - deletedate datetime
		name = q.getstr(9);                                   // 9 - name varchar(40)
		version = q.getval(10);                               // 10 - version int(11)
		fieldtype = q.getval(11);                             // 11 - fieldtype tinyint(1)
		charlength = q.getval(12);                            // 12 - charlength int(11)
		minvalue = q.getval(13);                              // 13 - minvalue int(11)
		maxvalue = q.getval(14);                              // 14 - maxvalue int(11)
		options = q.getstr(15);                               // 15 - options text
		ptrtotblnum = q.getval(16);                           // 16 - ptrtotblnum int(11)
		ordning = q.getval(17);                               // 17 - ordning int(11)
		integerlength = q.getval(18);                         // 18 - integerlength int(11)
		description = q.getstr(19);                           // 19 - description varchar(80)
		fieldstr = q.getstr(20);                              // 20 - fieldstr varchar(20)
		fieldflags = q.getval(21);                            // 21 - fieldflags tinyint(3)
		decimallength = q.getval(22);                         // 22 - decimallength int(11)
		defaultvalue = q.getstr(23);                          // 23 - defaultvalue varchar(40)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Flds::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	tblnum = qd -> getval(1);                                 // 1 - tblnum int(11)
	owner = qd -> getval(2);                                  // 2 - owner int(11)
	createdate = qd -> getstr(3);                             // 3 - createdate datetime
	changedby = qd -> getval(4);                              // 4 - changedby int(11)
	changedate = qd -> getstr(5);                             // 5 - changedate datetime
	deleted = qd -> getval(6);                                // 6 - deleted tinyint(1)
	deletedby = qd -> getval(7);                              // 7 - deletedby int(11)
	deletedate = qd -> getstr(8);                             // 8 - deletedate datetime
	name = qd -> getstr(9);                                   // 9 - name varchar(40)
	version = qd -> getval(10);                               // 10 - version int(11)
	fieldtype = qd -> getval(11);                             // 11 - fieldtype tinyint(1)
	charlength = qd -> getval(12);                            // 12 - charlength int(11)
	minvalue = qd -> getval(13);                              // 13 - minvalue int(11)
	maxvalue = qd -> getval(14);                              // 14 - maxvalue int(11)
	options = qd -> getstr(15);                               // 15 - options text
	ptrtotblnum = qd -> getval(16);                           // 16 - ptrtotblnum int(11)
	ordning = qd -> getval(17);                               // 17 - ordning int(11)
	integerlength = qd -> getval(18);                         // 18 - integerlength int(11)
	description = qd -> getstr(19);                           // 19 - description varchar(80)
	fieldstr = qd -> getstr(20);                              // 20 - fieldstr varchar(20)
	fieldflags = qd -> getval(21);                            // 21 - fieldflags tinyint(3)
	decimallength = qd -> getval(22);                         // 22 - decimallength int(11)
	defaultvalue = qd -> getstr(23);                          // 23 - defaultvalue varchar(40)
}


// End of implementation of class 'Flds'

} // End of namespace
namespace db {

/**
 **  Begin class 'Grplinks'
 **/

Grplinks::Grplinks(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Grplinks::Grplinks(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Grplinks::Grplinks(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Grplinks::Grplinks(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from grplinks where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Grplinks::~Grplinks()
{
}


void Grplinks::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Grplinks::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into grplinks(num,usernum,grpnum,dbnum)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> usernum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> grpnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> dbnum);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Grplinks::update()
{
	update(this -> num);
}


void Grplinks::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update grplinks set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", usernum=%ld",this -> usernum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", grpnum=%ld",this -> grpnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", dbnum=%ld",this -> dbnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Grplinks::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Grplinks::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from grplinks where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Grplinks::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<GRPLINKS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	sprintf(slask,"<GRPNUM>%ld</GRPNUM>",this -> grpnum);
	dest += slask;
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	dest += "</GRPLINKS>";
	return dest;
}


std::string Grplinks::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<GRPLINKS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	sprintf(slask,"<GRPNUM>%ld</GRPNUM>",this -> grpnum);
	dest += slask;
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	dest += "</GRPLINKS>";
	return dest;
}


size_t Grplinks::num_cols()
{
	return 4;
}


void Grplinks::clear()
{
	num = 0;
	usernum = 0;
	grpnum = 0;
	dbnum = 0;
}


void Grplinks::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,usernum,grpnum,dbnum " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		usernum = q.getval(1);                                // 1 - usernum int(11)
		grpnum = q.getval(2);                                 // 2 - grpnum int(11)
		dbnum = q.getval(3);                                  // 3 - dbnum int(11)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Grplinks::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	usernum = qd -> getval(1);                                // 1 - usernum int(11)
	grpnum = qd -> getval(2);                                 // 2 - grpnum int(11)
	dbnum = qd -> getval(3);                                  // 3 - dbnum int(11)
}


// End of implementation of class 'Grplinks'

} // End of namespace
namespace db {

/**
 **  Begin class 'Grps'
 **/

Grps::Grps(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Grps::Grps(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Grps::Grps(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Grps::Grps(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from grps where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Grps::~Grps()
{
}


void Grps::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Grps::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into grps(num,name,usernum)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> name) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> usernum);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Grps::update()
{
	update(this -> num);
}


void Grps::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update grps set num=%ld",this -> num);
		sql += slask;
	}
	sql += ", name='" + q.safestr(this -> name) + "'";
	{
		char slask[200];
		sprintf(slask,", usernum=%ld",this -> usernum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Grps::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Grps::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from grps where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Grps::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<GRPS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	dest += "</GRPS>";
	return dest;
}


std::string Grps::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<GRPS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	dest += "</GRPS>";
	return dest;
}


size_t Grps::num_cols()
{
	return 3;
}


void Grps::clear()
{
	num = 0;
	// 1 - name char(40)
	usernum = 0;
}


void Grps::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,name,usernum " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		name = q.getstr(1);                                   // 1 - name char(40)
		usernum = q.getval(2);                                // 2 - usernum int(11)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Grps::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	name = qd -> getstr(1);                                   // 1 - name char(40)
	usernum = qd -> getval(2);                                // 2 - usernum int(11)
}


// End of implementation of class 'Grps'

} // End of namespace
namespace db {

/**
 **  Begin class 'Indexlist'
 **/

Indexlist::Indexlist(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Indexlist::Indexlist(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Indexlist::Indexlist(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Indexlist::Indexlist(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from indexlist where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Indexlist::~Indexlist()
{
}


void Indexlist::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Indexlist::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into indexlist(num,indexnum,fldnum,length)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> indexnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> fldnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> length);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Indexlist::update()
{
	update(this -> num);
}


void Indexlist::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update indexlist set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", indexnum=%ld",this -> indexnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", fldnum=%ld",this -> fldnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", length=%ld",this -> length);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Indexlist::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Indexlist::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from indexlist where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Indexlist::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<INDEXLIST>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<INDEXNUM>%ld</INDEXNUM>",this -> indexnum);
	dest += slask;
	sprintf(slask,"<FLDNUM>%ld</FLDNUM>",this -> fldnum);
	dest += slask;
	sprintf(slask,"<LENGTH>%ld</LENGTH>",this -> length);
	dest += slask;
	dest += "</INDEXLIST>";
	return dest;
}


std::string Indexlist::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<INDEXLIST " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<INDEXNUM>%ld</INDEXNUM>",this -> indexnum);
	dest += slask;
	sprintf(slask,"<FLDNUM>%ld</FLDNUM>",this -> fldnum);
	dest += slask;
	sprintf(slask,"<LENGTH>%ld</LENGTH>",this -> length);
	dest += slask;
	dest += "</INDEXLIST>";
	return dest;
}


size_t Indexlist::num_cols()
{
	return 4;
}


void Indexlist::clear()
{
	num = 0;
	indexnum = 0;
	fldnum = 0;
	length = 0;
}


void Indexlist::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,indexnum,fldnum,length " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		indexnum = q.getval(1);                               // 1 - indexnum int(11)
		fldnum = q.getval(2);                                 // 2 - fldnum int(11)
		length = q.getval(3);                                 // 3 - length int(11)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Indexlist::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	indexnum = qd -> getval(1);                               // 1 - indexnum int(11)
	fldnum = qd -> getval(2);                                 // 2 - fldnum int(11)
	length = qd -> getval(3);                                 // 3 - length int(11)
}


// End of implementation of class 'Indexlist'

} // End of namespace
namespace db {

/**
 **  Begin class 'Indexs'
 **/

Indexs::Indexs(Database *db):typ(mmap_typ)
{
	database = db;
	new_object = 1;
	clear();
}


Indexs::Indexs(Database *db,const std::string& sql):typ(mmap_typ)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Indexs::Indexs(Database *db,Query *qd):typ(mmap_typ)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Indexs::Indexs(Database& db,long i_num):typ(mmap_typ),database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from indexs where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Indexs::~Indexs()
{
}


void Indexs::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Indexs::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into indexs(num,owner,createdate,changedby,changedate,deleted,deletedby,deletedate,name,version,tblnum,typ,description)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> owner);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> createdate) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> changedby);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> changedate) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> deleted);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> deletedby);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> deletedate) + "'";
	sql += ", '" + q.safestr(this -> name) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> version);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> tblnum);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> typ.String()) + "'";
	sql += ", '" + q.safestr(this -> description) + "'";
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Indexs::update()
{
	update(this -> num);
}


void Indexs::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update indexs set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", owner=%ld",this -> owner);
		sql += slask;
	}
	sql += ", createdate='" + q.safestr(this -> createdate) + "'";
	{
		char slask[200];
		sprintf(slask,", changedby=%ld",this -> changedby);
		sql += slask;
	}
	sql += ", changedate='" + q.safestr(this -> changedate) + "'";
	{
		char slask[200];
		sprintf(slask,", deleted=%d",this -> deleted);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", deletedby=%ld",this -> deletedby);
		sql += slask;
	}
	sql += ", deletedate='" + q.safestr(this -> deletedate) + "'";
	sql += ", name='" + q.safestr(this -> name) + "'";
	{
		char slask[200];
		sprintf(slask,", version=%ld",this -> version);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", tblnum=%ld",this -> tblnum);
		sql += slask;
	}
	sql += ", typ='" + q.safestr(this -> typ.String()) + "'";
	sql += ", description='" + q.safestr(this -> description) + "'";
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Indexs::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Indexs::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from indexs where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Indexs::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<INDEXS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<OWNER>%ld</OWNER>",this -> owner);
	dest += slask;
	dest += "<CREATEDATE>" + q.xmlsafestr(this -> createdate) + "</CREATEDATE>";
	sprintf(slask,"<CHANGEDBY>%ld</CHANGEDBY>",this -> changedby);
	dest += slask;
	dest += "<CHANGEDATE>" + q.xmlsafestr(this -> changedate) + "</CHANGEDATE>";
	sprintf(slask,"<DELETED>%d</DELETED>",this -> deleted);
	dest += slask;
	sprintf(slask,"<DELETEDBY>%ld</DELETEDBY>",this -> deletedby);
	dest += slask;
	dest += "<DELETEDATE>" + q.xmlsafestr(this -> deletedate) + "</DELETEDATE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<VERSION>%ld</VERSION>",this -> version);
	dest += slask;
	sprintf(slask,"<TBLNUM>%ld</TBLNUM>",this -> tblnum);
	dest += slask;
	dest += "<TYP>" + q.xmlsafestr(this -> typ.String()) + "</TYP>";
	dest += "<DESCRIPTION>" + q.xmlsafestr(this -> description) + "</DESCRIPTION>";
	dest += "</INDEXS>";
	return dest;
}


std::string Indexs::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<INDEXS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<OWNER>%ld</OWNER>",this -> owner);
	dest += slask;
	dest += "<CREATEDATE>" + q.xmlsafestr(this -> createdate) + "</CREATEDATE>";
	sprintf(slask,"<CHANGEDBY>%ld</CHANGEDBY>",this -> changedby);
	dest += slask;
	dest += "<CHANGEDATE>" + q.xmlsafestr(this -> changedate) + "</CHANGEDATE>";
	sprintf(slask,"<DELETED>%d</DELETED>",this -> deleted);
	dest += slask;
	sprintf(slask,"<DELETEDBY>%ld</DELETEDBY>",this -> deletedby);
	dest += slask;
	dest += "<DELETEDATE>" + q.xmlsafestr(this -> deletedate) + "</DELETEDATE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<VERSION>%ld</VERSION>",this -> version);
	dest += slask;
	sprintf(slask,"<TBLNUM>%ld</TBLNUM>",this -> tblnum);
	dest += slask;
	dest += "<TYP>" + q.xmlsafestr(this -> typ.String()) + "</TYP>";
	dest += "<DESCRIPTION>" + q.xmlsafestr(this -> description) + "</DESCRIPTION>";
	dest += "</INDEXS>";
	return dest;
}


size_t Indexs::num_cols()
{
	return 13;
}


void Indexs::clear()
{
	mmap_typ["INDEX"] = 1;
	mmap_typ["PRIMARY"] = 2;
	mmap_typ["UNIQUE"] = 3;
	mmap_typ["FULLTEXT"] = 4;
	num = 0;
	owner = 0;
	// 2 - createdate datetime
	changedby = 0;
	// 4 - changedate datetime
	deleted = 0;
	deletedby = 0;
	// 7 - deletedate datetime
	// 8 - name char(40)
	version = 0;
	tblnum = 0;
	// 11 - typ enum('INDEX','PRIMARY','UNIQUE','FULLTEXT')
	// 12 - description char(40)
}


void Indexs::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,owner,createdate,changedby,changedate,deleted,deletedby,deletedate,name,version,tblnum,typ,description " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		owner = q.getval(1);                                  // 1 - owner int(11)
		createdate = q.getstr(2);                             // 2 - createdate datetime
		changedby = q.getval(3);                              // 3 - changedby int(11)
		changedate = q.getstr(4);                             // 4 - changedate datetime
		deleted = q.getval(5);                                // 5 - deleted tinyint(1)
		deletedby = q.getval(6);                              // 6 - deletedby int(11)
		deletedate = q.getstr(7);                             // 7 - deletedate datetime
		name = q.getstr(8);                                   // 8 - name char(40)
		version = q.getval(9);                                // 9 - version int(11)
		tblnum = q.getval(10);                                // 10 - tblnum int(11)
		typ = q.getstr(11);                                   // 11 - typ enum('INDEX','PRIMARY','UNIQUE','FULLTEXT')
		description = q.getstr(12);                           // 12 - description char(40)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Indexs::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	owner = qd -> getval(1);                                  // 1 - owner int(11)
	createdate = qd -> getstr(2);                             // 2 - createdate datetime
	changedby = qd -> getval(3);                              // 3 - changedby int(11)
	changedate = qd -> getstr(4);                             // 4 - changedate datetime
	deleted = qd -> getval(5);                                // 5 - deleted tinyint(1)
	deletedby = qd -> getval(6);                              // 6 - deletedby int(11)
	deletedate = qd -> getstr(7);                             // 7 - deletedate datetime
	name = qd -> getstr(8);                                   // 8 - name char(40)
	version = qd -> getval(9);                                // 9 - version int(11)
	tblnum = qd -> getval(10);                                // 10 - tblnum int(11)
	typ = qd -> getstr(11);                                   // 11 - typ enum('INDEX','PRIMARY','UNIQUE','FULLTEXT')
	description = qd -> getstr(12);                           // 12 - description char(40)
}


// End of implementation of class 'Indexs'

} // End of namespace
namespace db {

/**
 **  Begin class 'Kommentar'
 **/

Kommentar::Kommentar(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Kommentar::Kommentar(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Kommentar::Kommentar(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Kommentar::Kommentar(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from kommentar where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Kommentar::~Kommentar()
{
}


void Kommentar::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Kommentar::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into kommentar(num,dbnum,tblnum,fldnum,usernum,dateposted,reason,kommentar,indexnum,appnum)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> dbnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> tblnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> fldnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> usernum);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> dateposted) + "'";
	sql += ", '" + q.safestr(this -> reason) + "'";
	sql += ", '" + q.safestr(this -> kommentar) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> indexnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> appnum);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Kommentar::update()
{
	update(this -> num);
}


void Kommentar::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update kommentar set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", dbnum=%ld",this -> dbnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", tblnum=%ld",this -> tblnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", fldnum=%ld",this -> fldnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", usernum=%ld",this -> usernum);
		sql += slask;
	}
	sql += ", dateposted='" + q.safestr(this -> dateposted) + "'";
	sql += ", reason='" + q.safestr(this -> reason) + "'";
	sql += ", kommentar='" + q.safestr(this -> kommentar) + "'";
	{
		char slask[200];
		sprintf(slask,", indexnum=%ld",this -> indexnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", appnum=%ld",this -> appnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Kommentar::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Kommentar::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from kommentar where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Kommentar::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<KOMMENTAR>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	sprintf(slask,"<TBLNUM>%ld</TBLNUM>",this -> tblnum);
	dest += slask;
	sprintf(slask,"<FLDNUM>%ld</FLDNUM>",this -> fldnum);
	dest += slask;
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	dest += "<DATEPOSTED>" + q.xmlsafestr(this -> dateposted) + "</DATEPOSTED>";
	dest += "<REASON>" + q.xmlsafestr(this -> reason) + "</REASON>";
	dest += "<KOMMENTAR>" + q.xmlsafestr(this -> kommentar) + "</KOMMENTAR>";
	sprintf(slask,"<INDEXNUM>%ld</INDEXNUM>",this -> indexnum);
	dest += slask;
	sprintf(slask,"<APPNUM>%ld</APPNUM>",this -> appnum);
	dest += slask;
	dest += "</KOMMENTAR>";
	return dest;
}


std::string Kommentar::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<KOMMENTAR " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	sprintf(slask,"<TBLNUM>%ld</TBLNUM>",this -> tblnum);
	dest += slask;
	sprintf(slask,"<FLDNUM>%ld</FLDNUM>",this -> fldnum);
	dest += slask;
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	dest += "<DATEPOSTED>" + q.xmlsafestr(this -> dateposted) + "</DATEPOSTED>";
	dest += "<REASON>" + q.xmlsafestr(this -> reason) + "</REASON>";
	dest += "<KOMMENTAR>" + q.xmlsafestr(this -> kommentar) + "</KOMMENTAR>";
	sprintf(slask,"<INDEXNUM>%ld</INDEXNUM>",this -> indexnum);
	dest += slask;
	sprintf(slask,"<APPNUM>%ld</APPNUM>",this -> appnum);
	dest += slask;
	dest += "</KOMMENTAR>";
	return dest;
}


size_t Kommentar::num_cols()
{
	return 10;
}


void Kommentar::clear()
{
	num = 0;
	dbnum = 0;
	tblnum = 0;
	fldnum = 0;
	usernum = 0;
	// 5 - dateposted datetime
	// 6 - reason varchar(80)
	// 7 - kommentar text
	indexnum = 0;
	appnum = 0;
}


void Kommentar::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,dbnum,tblnum,fldnum,usernum,dateposted,reason,kommentar,indexnum,appnum " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		dbnum = q.getval(1);                                  // 1 - dbnum int(11)
		tblnum = q.getval(2);                                 // 2 - tblnum int(11)
		fldnum = q.getval(3);                                 // 3 - fldnum int(11)
		usernum = q.getval(4);                                // 4 - usernum int(11)
		dateposted = q.getstr(5);                             // 5 - dateposted datetime
		reason = q.getstr(6);                                 // 6 - reason varchar(80)
		kommentar = q.getstr(7);                              // 7 - kommentar text
		indexnum = q.getval(8);                               // 8 - indexnum int(11)
		appnum = q.getval(9);                                 // 9 - appnum int(11)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Kommentar::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	dbnum = qd -> getval(1);                                  // 1 - dbnum int(11)
	tblnum = qd -> getval(2);                                 // 2 - tblnum int(11)
	fldnum = qd -> getval(3);                                 // 3 - fldnum int(11)
	usernum = qd -> getval(4);                                // 4 - usernum int(11)
	dateposted = qd -> getstr(5);                             // 5 - dateposted datetime
	reason = qd -> getstr(6);                                 // 6 - reason varchar(80)
	kommentar = qd -> getstr(7);                              // 7 - kommentar text
	indexnum = qd -> getval(8);                               // 8 - indexnum int(11)
	appnum = qd -> getval(9);                                 // 9 - appnum int(11)
}


// End of implementation of class 'Kommentar'

} // End of namespace
namespace db {

/**
 **  Begin class 'Tblgrps'
 **/

Tblgrps::Tblgrps(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Tblgrps::Tblgrps(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Tblgrps::Tblgrps(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Tblgrps::Tblgrps(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from tblgrps where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Tblgrps::~Tblgrps()
{
}


void Tblgrps::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Tblgrps::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into tblgrps(num,name,dbnum)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> name) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> dbnum);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Tblgrps::update()
{
	update(this -> num);
}


void Tblgrps::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update tblgrps set num=%ld",this -> num);
		sql += slask;
	}
	sql += ", name='" + q.safestr(this -> name) + "'";
	{
		char slask[200];
		sprintf(slask,", dbnum=%ld",this -> dbnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Tblgrps::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Tblgrps::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from tblgrps where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Tblgrps::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<TBLGRPS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	dest += "</TBLGRPS>";
	return dest;
}


std::string Tblgrps::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<TBLGRPS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	dest += "</TBLGRPS>";
	return dest;
}


size_t Tblgrps::num_cols()
{
	return 3;
}


void Tblgrps::clear()
{
	num = 0;
	// 1 - name char(40)
	dbnum = 0;
}


void Tblgrps::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,name,dbnum " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		name = q.getstr(1);                                   // 1 - name char(40)
		dbnum = q.getval(2);                                  // 2 - dbnum int(11)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Tblgrps::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	name = qd -> getstr(1);                                   // 1 - name char(40)
	dbnum = qd -> getval(2);                                  // 2 - dbnum int(11)
}


// End of implementation of class 'Tblgrps'

} // End of namespace
namespace db {

/**
 **  Begin class 'Tbls'
 **/

Tbls::Tbls(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Tbls::Tbls(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Tbls::Tbls(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Tbls::Tbls(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from tbls where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Tbls::~Tbls()
{
}


void Tbls::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Tbls::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into tbls(num,dbnum,owner,createdate,changedby,changedate,deleted,deletedby,deletedate,name,version,description,tblgrpnum)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> dbnum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> owner);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> createdate) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> changedby);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> changedate) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> deleted);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> deletedby);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> deletedate) + "'";
	sql += ", '" + q.safestr(this -> name) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> version);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> description) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> tblgrpnum);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Tbls::update()
{
	update(this -> num);
}


void Tbls::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update tbls set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", dbnum=%ld",this -> dbnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", owner=%ld",this -> owner);
		sql += slask;
	}
	sql += ", createdate='" + q.safestr(this -> createdate) + "'";
	{
		char slask[200];
		sprintf(slask,", changedby=%ld",this -> changedby);
		sql += slask;
	}
	sql += ", changedate='" + q.safestr(this -> changedate) + "'";
	{
		char slask[200];
		sprintf(slask,", deleted=%d",this -> deleted);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", deletedby=%ld",this -> deletedby);
		sql += slask;
	}
	sql += ", deletedate='" + q.safestr(this -> deletedate) + "'";
	sql += ", name='" + q.safestr(this -> name) + "'";
	{
		char slask[200];
		sprintf(slask,", version=%ld",this -> version);
		sql += slask;
	}
	sql += ", description='" + q.safestr(this -> description) + "'";
	{
		char slask[200];
		sprintf(slask,", tblgrpnum=%ld",this -> tblgrpnum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Tbls::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Tbls::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from tbls where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Tbls::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<TBLS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	sprintf(slask,"<OWNER>%ld</OWNER>",this -> owner);
	dest += slask;
	dest += "<CREATEDATE>" + q.xmlsafestr(this -> createdate) + "</CREATEDATE>";
	sprintf(slask,"<CHANGEDBY>%ld</CHANGEDBY>",this -> changedby);
	dest += slask;
	dest += "<CHANGEDATE>" + q.xmlsafestr(this -> changedate) + "</CHANGEDATE>";
	sprintf(slask,"<DELETED>%d</DELETED>",this -> deleted);
	dest += slask;
	sprintf(slask,"<DELETEDBY>%ld</DELETEDBY>",this -> deletedby);
	dest += slask;
	dest += "<DELETEDATE>" + q.xmlsafestr(this -> deletedate) + "</DELETEDATE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<VERSION>%ld</VERSION>",this -> version);
	dest += slask;
	dest += "<DESCRIPTION>" + q.xmlsafestr(this -> description) + "</DESCRIPTION>";
	sprintf(slask,"<TBLGRPNUM>%ld</TBLGRPNUM>",this -> tblgrpnum);
	dest += slask;
	dest += "</TBLS>";
	return dest;
}


std::string Tbls::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<TBLS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<DBNUM>%ld</DBNUM>",this -> dbnum);
	dest += slask;
	sprintf(slask,"<OWNER>%ld</OWNER>",this -> owner);
	dest += slask;
	dest += "<CREATEDATE>" + q.xmlsafestr(this -> createdate) + "</CREATEDATE>";
	sprintf(slask,"<CHANGEDBY>%ld</CHANGEDBY>",this -> changedby);
	dest += slask;
	dest += "<CHANGEDATE>" + q.xmlsafestr(this -> changedate) + "</CHANGEDATE>";
	sprintf(slask,"<DELETED>%d</DELETED>",this -> deleted);
	dest += slask;
	sprintf(slask,"<DELETEDBY>%ld</DELETEDBY>",this -> deletedby);
	dest += slask;
	dest += "<DELETEDATE>" + q.xmlsafestr(this -> deletedate) + "</DELETEDATE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<VERSION>%ld</VERSION>",this -> version);
	dest += slask;
	dest += "<DESCRIPTION>" + q.xmlsafestr(this -> description) + "</DESCRIPTION>";
	sprintf(slask,"<TBLGRPNUM>%ld</TBLGRPNUM>",this -> tblgrpnum);
	dest += slask;
	dest += "</TBLS>";
	return dest;
}


size_t Tbls::num_cols()
{
	return 13;
}


void Tbls::clear()
{
	num = 0;
	dbnum = 0;
	owner = 0;
	// 3 - createdate datetime
	changedby = 0;
	// 5 - changedate datetime
	deleted = 0;
	deletedby = 0;
	// 8 - deletedate datetime
	// 9 - name char(40)
	version = 0;
	// 11 - description char(80)
	tblgrpnum = 0;
}


void Tbls::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,dbnum,owner,createdate,changedby,changedate,deleted,deletedby,deletedate,name,version,description,tblgrpnum " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		dbnum = q.getval(1);                                  // 1 - dbnum int(11)
		owner = q.getval(2);                                  // 2 - owner int(11)
		createdate = q.getstr(3);                             // 3 - createdate datetime
		changedby = q.getval(4);                              // 4 - changedby int(11)
		changedate = q.getstr(5);                             // 5 - changedate datetime
		deleted = q.getval(6);                                // 6 - deleted tinyint(1)
		deletedby = q.getval(7);                              // 7 - deletedby int(11)
		deletedate = q.getstr(8);                             // 8 - deletedate datetime
		name = q.getstr(9);                                   // 9 - name char(40)
		version = q.getval(10);                               // 10 - version int(11)
		description = q.getstr(11);                           // 11 - description char(80)
		tblgrpnum = q.getval(12);                             // 12 - tblgrpnum int(11)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Tbls::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	dbnum = qd -> getval(1);                                  // 1 - dbnum int(11)
	owner = qd -> getval(2);                                  // 2 - owner int(11)
	createdate = qd -> getstr(3);                             // 3 - createdate datetime
	changedby = qd -> getval(4);                              // 4 - changedby int(11)
	changedate = qd -> getstr(5);                             // 5 - changedate datetime
	deleted = qd -> getval(6);                                // 6 - deleted tinyint(1)
	deletedby = qd -> getval(7);                              // 7 - deletedby int(11)
	deletedate = qd -> getstr(8);                             // 8 - deletedate datetime
	name = qd -> getstr(9);                                   // 9 - name char(40)
	version = qd -> getval(10);                               // 10 - version int(11)
	description = qd -> getstr(11);                           // 11 - description char(80)
	tblgrpnum = qd -> getval(12);                             // 12 - tblgrpnum int(11)
}


// End of implementation of class 'Tbls'

} // End of namespace
namespace db {

/**
 **  Begin class 'Users'
 **/

Users::Users(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Users::Users(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Users::Users(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Users::Users(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from users where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Users::~Users()
{
}


void Users::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Users::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into users(num,handle,name,password,superuser,email,icq,prevdatum,thisdatum,maxdbs,maxtbls,maxflds,flags,steps,maxindexs,maxapps,cutoff)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> handle) + "'";
	sql += ", '" + q.safestr(this -> name) + "'";
	sql += ", '" + q.safestr(this -> password) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> superuser);
		sql += slask;
	}
	sql += ", '" + q.safestr(this -> email) + "'";
	sql += ", '" + q.safestr(this -> icq) + "'";
	sql += ", '" + q.safestr(this -> prevdatum) + "'";
	sql += ", '" + q.safestr(this -> thisdatum) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> maxdbs);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> maxtbls);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> maxflds);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> flags);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> steps);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> maxindexs);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> maxapps);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> cutoff);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Users::update()
{
	update(this -> num);
}


void Users::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update users set num=%ld",this -> num);
		sql += slask;
	}
	sql += ", handle='" + q.safestr(this -> handle) + "'";
	sql += ", name='" + q.safestr(this -> name) + "'";
	sql += ", password='" + q.safestr(this -> password) + "'";
	{
		char slask[200];
		sprintf(slask,", superuser=%d",this -> superuser);
		sql += slask;
	}
	sql += ", email='" + q.safestr(this -> email) + "'";
	sql += ", icq='" + q.safestr(this -> icq) + "'";
	sql += ", prevdatum='" + q.safestr(this -> prevdatum) + "'";
	sql += ", thisdatum='" + q.safestr(this -> thisdatum) + "'";
	{
		char slask[200];
		sprintf(slask,", maxdbs=%ld",this -> maxdbs);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", maxtbls=%ld",this -> maxtbls);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", maxflds=%ld",this -> maxflds);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", flags=%ld",this -> flags);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", steps=%ld",this -> steps);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", maxindexs=%ld",this -> maxindexs);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", maxapps=%ld",this -> maxapps);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", cutoff=%ld",this -> cutoff);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Users::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Users::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from users where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Users::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<USERS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<HANDLE>" + q.xmlsafestr(this -> handle) + "</HANDLE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	dest += "<PASSWORD>" + q.xmlsafestr(this -> password) + "</PASSWORD>";
	sprintf(slask,"<SUPERUSER>%d</SUPERUSER>",this -> superuser);
	dest += slask;
	dest += "<EMAIL>" + q.xmlsafestr(this -> email) + "</EMAIL>";
	dest += "<ICQ>" + q.xmlsafestr(this -> icq) + "</ICQ>";
	dest += "<PREVDATUM>" + q.xmlsafestr(this -> prevdatum) + "</PREVDATUM>";
	dest += "<THISDATUM>" + q.xmlsafestr(this -> thisdatum) + "</THISDATUM>";
	sprintf(slask,"<MAXDBS>%ld</MAXDBS>",this -> maxdbs);
	dest += slask;
	sprintf(slask,"<MAXTBLS>%ld</MAXTBLS>",this -> maxtbls);
	dest += slask;
	sprintf(slask,"<MAXFLDS>%ld</MAXFLDS>",this -> maxflds);
	dest += slask;
	sprintf(slask,"<FLAGS>%ld</FLAGS>",this -> flags);
	dest += slask;
	sprintf(slask,"<STEPS>%ld</STEPS>",this -> steps);
	dest += slask;
	sprintf(slask,"<MAXINDEXS>%ld</MAXINDEXS>",this -> maxindexs);
	dest += slask;
	sprintf(slask,"<MAXAPPS>%ld</MAXAPPS>",this -> maxapps);
	dest += slask;
	sprintf(slask,"<CUTOFF>%ld</CUTOFF>",this -> cutoff);
	dest += slask;
	dest += "</USERS>";
	return dest;
}


std::string Users::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<USERS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<HANDLE>" + q.xmlsafestr(this -> handle) + "</HANDLE>";
	dest += "<NAME>" + q.xmlsafestr(this -> name) + "</NAME>";
	dest += "<PASSWORD>" + q.xmlsafestr(this -> password) + "</PASSWORD>";
	sprintf(slask,"<SUPERUSER>%d</SUPERUSER>",this -> superuser);
	dest += slask;
	dest += "<EMAIL>" + q.xmlsafestr(this -> email) + "</EMAIL>";
	dest += "<ICQ>" + q.xmlsafestr(this -> icq) + "</ICQ>";
	dest += "<PREVDATUM>" + q.xmlsafestr(this -> prevdatum) + "</PREVDATUM>";
	dest += "<THISDATUM>" + q.xmlsafestr(this -> thisdatum) + "</THISDATUM>";
	sprintf(slask,"<MAXDBS>%ld</MAXDBS>",this -> maxdbs);
	dest += slask;
	sprintf(slask,"<MAXTBLS>%ld</MAXTBLS>",this -> maxtbls);
	dest += slask;
	sprintf(slask,"<MAXFLDS>%ld</MAXFLDS>",this -> maxflds);
	dest += slask;
	sprintf(slask,"<FLAGS>%ld</FLAGS>",this -> flags);
	dest += slask;
	sprintf(slask,"<STEPS>%ld</STEPS>",this -> steps);
	dest += slask;
	sprintf(slask,"<MAXINDEXS>%ld</MAXINDEXS>",this -> maxindexs);
	dest += slask;
	sprintf(slask,"<MAXAPPS>%ld</MAXAPPS>",this -> maxapps);
	dest += slask;
	sprintf(slask,"<CUTOFF>%ld</CUTOFF>",this -> cutoff);
	dest += slask;
	dest += "</USERS>";
	return dest;
}


size_t Users::num_cols()
{
	return 17;
}


void Users::clear()
{
	num = 0;
	// 1 - handle char(20)
	// 2 - name char(40)
	// 3 - password char(20)
	superuser = 0;
	// 5 - email char(60)
	// 6 - icq char(20)
	// 7 - prevdatum datetime
	// 8 - thisdatum datetime
	maxdbs = 0;
	maxtbls = 0;
	maxflds = 0;
	flags = 0;
	steps = 0;
	maxindexs = 0;
	maxapps = 0;
	cutoff = 0;
}


void Users::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,handle,name,password,superuser,email,icq,prevdatum,thisdatum,maxdbs,maxtbls,maxflds,flags,steps,maxindexs,maxapps,cutoff " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		handle = q.getstr(1);                                 // 1 - handle char(20)
		name = q.getstr(2);                                   // 2 - name char(40)
		password = q.getstr(3);                               // 3 - password char(20)
		superuser = q.getval(4);                              // 4 - superuser tinyint(1)
		email = q.getstr(5);                                  // 5 - email char(60)
		icq = q.getstr(6);                                    // 6 - icq char(20)
		prevdatum = q.getstr(7);                              // 7 - prevdatum datetime
		thisdatum = q.getstr(8);                              // 8 - thisdatum datetime
		maxdbs = q.getval(9);                                 // 9 - maxdbs int(11)
		maxtbls = q.getval(10);                               // 10 - maxtbls int(11)
		maxflds = q.getval(11);                               // 11 - maxflds int(11)
		flags = q.getval(12);                                 // 12 - flags int(11)
		steps = q.getval(13);                                 // 13 - steps int(11)
		maxindexs = q.getval(14);                             // 14 - maxindexs int(11)
		maxapps = q.getval(15);                               // 15 - maxapps int(11)
		cutoff = q.getval(16);                                // 16 - cutoff int(11)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Users::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	handle = qd -> getstr(1);                                 // 1 - handle char(20)
	name = qd -> getstr(2);                                   // 2 - name char(40)
	password = qd -> getstr(3);                               // 3 - password char(20)
	superuser = qd -> getval(4);                              // 4 - superuser tinyint(1)
	email = qd -> getstr(5);                                  // 5 - email char(60)
	icq = qd -> getstr(6);                                    // 6 - icq char(20)
	prevdatum = qd -> getstr(7);                              // 7 - prevdatum datetime
	thisdatum = qd -> getstr(8);                              // 8 - thisdatum datetime
	maxdbs = qd -> getval(9);                                 // 9 - maxdbs int(11)
	maxtbls = qd -> getval(10);                               // 10 - maxtbls int(11)
	maxflds = qd -> getval(11);                               // 11 - maxflds int(11)
	flags = qd -> getval(12);                                 // 12 - flags int(11)
	steps = qd -> getval(13);                                 // 13 - steps int(11)
	maxindexs = qd -> getval(14);                             // 14 - maxindexs int(11)
	maxapps = qd -> getval(15);                               // 15 - maxapps int(11)
	cutoff = qd -> getval(16);                                // 16 - cutoff int(11)
}


// End of implementation of class 'Users'

} // End of namespace
namespace db {

/**
 **  Begin class 'Valid'
 **/

Valid::Valid(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Valid::Valid(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Valid::Valid(Database *db,Query *qd)
{
	database = db;
	new_object = 0;
	spawn(qd);
}


Valid::Valid(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from valid where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Valid::~Valid()
{
}


void Valid::select(const std::string& sql)
{
	spawn(sql);
}


my_ulonglong Valid::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into valid(num,usernum,valid)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> num);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> usernum);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> valid);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	my_ulonglong inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Valid::update()
{
	update(this -> num);
}


void Valid::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update valid set num=%ld",this -> num);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", usernum=%ld",this -> usernum);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", valid=%ld",this -> valid);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Valid::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Valid::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from valid where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Valid::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<VALID>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	sprintf(slask,"<VALID>%ld</VALID>",this -> valid);
	dest += slask;
	dest += "</VALID>";
	return dest;
}


std::string Valid::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<VALID " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<USERNUM>%ld</USERNUM>",this -> usernum);
	dest += slask;
	sprintf(slask,"<VALID>%ld</VALID>",this -> valid);
	dest += slask;
	dest += "</VALID>";
	return dest;
}


size_t Valid::num_cols()
{
	return 3;
}


void Valid::clear()
{
	num = 0;
	usernum = 0;
	valid = 0;
}


void Valid::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,usernum,valid " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		num = q.getval(0);                                    // 0 - num int(11)
		usernum = q.getval(1);                                // 1 - usernum int(11)
		valid = q.getval(2);                                  // 2 - valid int(11)
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Valid::spawn(Query *qd)
{
	clear();

	num = qd -> getval(0);                                    // 0 - num int(11)
	usernum = qd -> getval(1);                                // 1 - usernum int(11)
	valid = qd -> getval(2);                                  // 2 - valid int(11)
}


// End of implementation of class 'Valid'

} // End of namespace
